// LinkItUp
// This function takes in a string and tries to link up any urls it finds
// Usage: var linked_text = str.linkItUp(); * more below
// Some known issues, but fixable:
// - no love for localhost
// - this will screw up any url that's already linked up. e.g. <a href="http://google.com">google</a>
//
/*
	Date:			2008-02-21
	User:			Lior Gonda
	Modification:
		Usage:
			If parameter 'linkText' is pased to function, then the link will be formated to it. text '{href}' will be replaced by the href
		Exmaples:
			linkText = '<a href="{href}">{url}</a>'
			linkText = '<a href="#" class="" onclick="doSomething('{href}')">{url}</a>'
*/
        
String.urlPattern = /((http|https|ftp):\/\/)?(([a-z0-9_]+):([a-z0-9-_]*)@)?(([a-z0-9_-]+\.)*)(([a-z0-9-]{2,})\.)(com|net|org|edu|gov|mil|int|arpa|aero|biz|coop|info|museum|name|ad|ae|af|ag|ai|al|am|an|ao|aq|ar|as|at|au|aw|az|ba|bb|bd|be|bf|bg|bh|bi|bj|bm|bn|bo|br|bs|bt|bv|bw|by|bz|ca|cc|cf|cd|cg|ch|ci|ck|cl|cm|cn|co|cr|cs|cu|cv|cx|cy|cz|de|dj|dk|dm|do|dz|ec|ee|eg|eh|er|es|et|fi|fj|fk|fm|fo|fr|fx|ga|gb|gd|ge|gf|gh|gi|gl|gm|gn|gp|gq|gr|gs|gt|gu|gw|gy|hk|hm|hn|hr|ht|hu|id|ie|il|in|io|iq|ir|is|it|jm|jo|jp|ke|kg|kh|ki|km|kn|kp|kr|kw|ky|kz|la|lb|lc|li|lk|lr|ls|lt|lu|lv|ly|ma|mc|md|mg|mh|mk|ml|mm|mn|mo|mp|mq|mr|ms|mt|mu|mv|mw|mx|my|mz|na|nc|ne|nf|ng|ni|nl|no|np|nr|nt|nu|nz|om|pa|pe|pf|pg|ph|pk|pl|pm|pn|pr|pt|pw|py|qa|re|ro|ru|rw|sa|sb|sc|sd|se|sg|sh|si|sj|sk|sl|sm|sn|so|sr|st|su|sv|sy|sz|tc|td|tf|tg|th|tj|tk|tm|tn|to|tp|tr|tt|tv|tw|tz|ua|ug|uk|um|us|uy|uz|va|vc|ve|vg|vi|vn|vu|wf|ws|ye|yt|yu|za|zm|zr|zw)(:(\d+))?((\/[a-z0-9-_.%~]*)*)?(\?[^? ]*)?(#[\w\-]+)?/ig;

String.prototype.linkItUp = function( linkText ) {

        if (this == null) return this;

        var left_pos			= 0;
        var left_url_pos		= 0;
        var new_str				= "";
        var linkTextRetainer	= linkText;
        var matches;
        while ((matches = String.urlPattern.exec(this)) != null) {
			    linkText = linkTextRetainer;
				var url = matches[0];
                var href = url;
                if (!matches[1]) {
                        // no protocol - we'll guess that it is http://
                        href = "http://" + url;
                }
				
                // grab the first character of the url
                left_url_pos = String.urlPattern.lastIndex - url.length;
				
                if (left_pos < left_url_pos) {
                        new_str += this.substring(left_pos, left_url_pos);
                        left_pos = left_url_pos;
                }
				
//				if( url.length > 30 ){
//					url = url.substring(0,30) + '...'
//				}
								
				if( typeof linkText == 'undefined' ){
					linkText = '<a href="' + href + '" target="_blank">' + url + '</a>';
				}
				else{
					linkText = linkText.replace("{href}", href).replace("{url}", url);
				}
                new_str += linkText;
                left_pos = String.urlPattern.lastIndex;
        }

        // grab the text at the end of the input string if we missed any
        new_str += this.substring(left_pos);

        return new_str;
}
