// =========================================
// ================== INITS ================
// =========================================
// ------------ htmlRendererInit ------------
function htmlRendererInit(){
	var stLocal							= {};
	stLocal.aFiles						= ['grid','list','listHeader','shadowBefore','shadowAfter','noGrid'];
	stLocal.aFilesPre					= ['note','place','link'];
	stLocal.aFilesPost					= ['Grid','List','Float'];
	stLocal.textStream					= new air.FileStream();
	
	for( stLocal.file_idx = 0; stLocal.file_idx < stLocal.aFiles.length; stLocal.file_idx++ ){
		stLocal.textFile	= new air.File("app:/templates/" + stLocal.aFiles[stLocal.file_idx] + ".html");
		if(stLocal.textFile.exists){
			stLocal.textStream.open(stLocal.textFile, air.FileMode.READ);
			this[stLocal.aFiles[stLocal.file_idx]] = stLocal.textStream.readUTFBytes(stLocal.textStream.bytesAvailable);
		}
	}
	
	for( stLocal.filePre_idx = 0; stLocal.filePre_idx < stLocal.aFilesPre.length; stLocal.filePre_idx++ ){
		for( stLocal.filePost_idx = 0; stLocal.filePost_idx < stLocal.aFilesPost.length; stLocal.filePost_idx++ ){
			stLocal.fileName			= stLocal.aFilesPre[stLocal.filePre_idx] + stLocal.aFilesPost[stLocal.filePost_idx];
			stLocal.textFile			= new air.File("app:/templates/" + stLocal.fileName + ".html");
			if( stLocal.textFile.exists ){
				stLocal.textStream.open(stLocal.textFile, air.FileMode.READ);
				this[stLocal.fileName]	= stLocal.textStream.readUTFBytes(stLocal.textStream.bytesAvailable);
			}
		}
	}
		
	stLocal.textStream.close();
}

// =========================================
// ============= TEMPLATE RENDER ===========
// =========================================
// ------------ htmlShadowBefore ------------
function htmlShadowBefore(){
	return this.shadowBefore;
}

// ------------ htmlShadowAfter ------------
function htmlShadowAfter(){
	return this.shadowAfter;
}

// ------------ htmlGrid ------------
function htmlGrid(){
	return this.grid;
}

// ------------ htmlList ------------
function htmlList(){
	return this.list;
}

// ------------ htmlListHeader ------------
function htmlListHeader( dateStamp ){
	var data =	{
					"dateStamp": dateStamp
				};
	
	return this.listHeader.supplant(data);
}

// ------------ htmlNoteGrid ------------
function htmlNoteGrid( noteId, content, tag, dateStamp, archived ){
	var stLocal		= {};
	if( archived == true ){
		stLocal.archived = '1';
	}
	else{
		stLocal.archived = '0';
	}
	
	var data =	{
					"noteId": noteId,
					"content": content,
					"content_header": stringToMapFormat( content ),
					"content_html": stringToHtml( content ),
					"content_textarea": stringToTextareaFormat( content ),
					"tag": tag,
					"archived": stLocal.archived,
					"dateStamp": dateFormat( dateStamp, 1 )
				};

	return this.noteGrid.supplant(data);
}

// ------------ htmlPlaceGrid ------------
function htmlPlaceGrid( noteId, content, tag, image, dateStamp, archived ){
	var stLocal		= {};
	if( archived == true ){
		stLocal.archived = '1';
	}
	else{
		stLocal.archived = '0';
	}
	
	var data =	{
					"noteId": noteId,
					"content": content,
					"content_header": stringToMapFormat( content ),
					"content_html": stringToHtml( content ),
					"content_textarea": stringToTextareaFormat( content ),
					"tag": tag,
					"image": image,
					"archived": stLocal.archived,
					"dateStamp": dateFormat( dateStamp, 1 )
				};
	
	return this.placeGrid.supplant(data);
}

// ------------ htmlLinkGrid ------------
function htmlLinkGrid( noteId, content, tag, dateStamp, archived ){
	var stLocal		= {};
	if( archived == true ){
		stLocal.archived = '1';
	}
	else{
		stLocal.archived = '0';
	}
	
	var data =	{
					"noteId": noteId,
					"content": content,
					"content_header": stringToMapFormat( content ),
					"content_html": content.linkItUp( '<a href="#" class="link" content="{href}">{url}</a>' ),
					"content_textarea": stringToTextareaFormat( content ),
					"tag": tag,
					"archived": stLocal.archived,
					"dateStamp": dateFormat( dateStamp, 1 )
				};
	
	return this.linkGrid.supplant(data);
}

// ------------ htmlNoMsgGrid ------------
function htmlNoMsgGrid(){
	return this.noGrid;
}

// ------------ htmlNoteList ------------
function htmlNoteList( noteId, content, tag, dateStamp, archived ){
	var stLocal		= {};
	if( archived == true ){
		stLocal.archived = '1';
	}
	else{
		stLocal.archived = '0';
	}
	
	var data =	{
					"noteId": noteId,
					"content": content,
					"content_header": stringToMapFormat( content ),
					"content_html": stringToHtml( content ),
					"content_textarea": stringToTextareaFormat( content ),
					"tag": tag,
					"archived": stLocal.archived,
					"dateStamp": dateFormat( dateStamp, 2 )
				};

	return this.noteList.supplant(data);
}

// ------------ htmlPlaceList ------------
function htmlPlaceList( noteId, content, tag, image, dateStamp, archived ){
	var stLocal		= {};
	if( archived == true ){
		stLocal.archived = '1';
	}
	else{
		stLocal.archived = '0';
	}
	
	var data =	{
					"noteId": noteId,
					"content": content,
					"content_header": stringToMapFormat( content ),
					"content_html": stringToHtml( content ),
					"content_textarea": stringToTextareaFormat( content ),
					"tag": tag,
					"image": image,
					"archived": stLocal.archived,
					"dateStamp": dateFormat( dateStamp, 2 )
				};
	
	return this.placeList.supplant(data);
}

// ------------ htmlLinkList ------------
function htmlLinkList( noteId, content, tag, dateStamp, archived ){
	var stLocal		= {};
	if( archived == true ){
		stLocal.archived = '1';
	}
	else{
		stLocal.archived = '0';
	}
	
	var data =	{
					"noteId": noteId,
					"content": content,
					"content_header": stringToMapFormat( content ),
					"content_html": content.linkItUp( '<a href="#" class="link" content="{href}">{url}</a>' ),
					"content_textarea": stringToTextareaFormat( content ),
					"tag": tag,
					"archived": stLocal.archived,
					"dateStamp": dateFormat( dateStamp, 2 )
				};
	
	return this.linkList.supplant(data);
}

// ------------ htmlNoteFloat ------------
function htmlNoteFloat( noteId, content, tag, dateStamp, archived ){
	var stLocal		= {};
	if( archived == true ){
		stLocal.archived = '1';
	}
	else{
		stLocal.archived = '0';
	}
	
	var data =	{
					"noteId": noteId,
					"content": content,
					"content_header": stringToMapFormat( content ),
					"content_html": stringToHtml( content ),
					"content_textarea": stringToTextareaFormat( content ),
					"tag": tag,
					"archived": stLocal.archived,
					"dateStamp": dateFormat( dateStamp, 1 )
				};

	return htmlShadowBefore() + this.noteFloat.supplant(data) + htmlShadowAfter();
}

// ------------ htmlPlaceFloat ------------
function htmlPlaceFloat( noteId, content, tag, image, dateStamp, archived ){
	var stLocal		= {};
	if( archived == true ){
		stLocal.archived = '1';
	}
	else{
		stLocal.archived = '0';
	}
	
	var data =	{
					"noteId": noteId,
					"content": content,
					"content_header": stringToMapFormat( content ),
					"content_html": stringToHtml( content ),
					"content_textarea": stringToTextareaFormat( content ),
					"tag": tag,
					"image": image,
					"archived": stLocal.archived,
					"dateStamp": dateFormat( dateStamp, 1 )
				};

	return htmlShadowBefore() + this.placeFloat.supplant(data) + htmlShadowAfter();
}

// ------------ htmlLinkFloat ------------
function htmlLinkFloat( noteId, content, tag, dateStamp, archived ){
	var stLocal		= {};
	if( archived == true ){
		stLocal.archived = '1';
	}
	else{
		stLocal.archived = '0';
	}
	
	var data =	{
					"noteId": noteId,
					"content": content,
					"content_header": stringToMapFormat( content ),
					"content_html": content.linkItUp( '<a href="#" class="link" content="{href}">{url}</a>' ),
					"content_textarea": stringToTextareaFormat( content ),
					"tag": tag,
					"archived": stLocal.archived,
					"dateStamp": dateFormat( dateStamp, 1 )
				};

	return htmlShadowBefore() + this.linkFloat.supplant(data) + htmlShadowAfter();
}

// =========================================
// ============ GLOBAL FUNCTION ============
// =========================================
// string supplant
String.prototype.supplant = function (o) { 
    return this.replace(/{([^{}]*)}/g, 
        function (a, b) {
			var rtn;
            var r = o[b];
            rtn = typeof r === 'string' || typeof r === 'number' ? 
                r : a; 
			return rtn;
        }
    ); 
};
