﻿// global vars
var nameSpace = {};

// Extend jquery with a cacheless version of html.
$.fn.extend({
	html2: function html2(value){
		if(value == undefined)
			return (this.length ? this[0].innerHTML : null);
		else if(this.length)
			this[0].innerHTML = value;
		return this;
	}
});


function tagKeyPress(ev) {
	if(ev.which == 13)
		doAddNote();
}

// =========================================
// ================= INIT ==================
// =========================================
// ------------ appLoad ------------
function appLoad(){
	setSettings();
	doSQLLoad();
	checkConnection();
	doControlsLoad();
	htmlRendererInit();
	showTrayIcon();
	updaterLoad();

	//ADDED:
	loadGlobalEvents();
	staySane();

}

function staySane() {

	if(window.nativeWindow.visible) {
		var R = new air.Rectangle(window.nativeWindow.x, window.nativeWindow.y, window.nativeWindow.width, window.nativeWindow.height);
 		if((window.nativeWindow.x < 0 || window.nativeWindow.y < 0) ||
			(air.Screen.getScreensForRectangle(R).length==0)) {
			window.nativeWindow.x = air.Screen.mainScreen.bounds.width / 2;
			window.nativeWindow.y = air.Screen.mainScreen.bounds.height / 4;
 		}

	}

	// every two seconds
	_setTimeout(staySane, 2000);
}

// ------------ appUnload ------------
function appUnload(){
	doCloseAllFloat();
	air.NativeApplication.nativeApplication.icon.bitmaps = [];
	air.NativeApplication.nativeApplication.exit();
	clearTimers();
	doSQLUnload();
}

nativeWindow.addEventListener('closing', function(){
	//use closing event, because window.unload cannot use runtime or alert
	appUnload();
});

nativeWindow.addEventListener(air.NativeWindowDisplayStateEvent.DISPLAY_STATE_CHANGE, function(event){
	if (event.afterDisplayState == air.NativeWindowDisplayState.NORMAL)
	{
		window.nativeWindow.visible = true;
		window.nativeWindow.activate();
		doShowAllFloat();
	}
	else if (event.afterDisplayState == air.NativeWindowDisplayState.MINIMIZED) {
		var stLocal = {};
		for( stLocal.thisFloatingNote in nameSpace.floating ){
		stLocal.thisWindow	= nameSpace.floating[stLocal.thisFloatingNote].window;
		if( typeof stLocal.thisWindow != 'undefined' ){
		}
	}
	}
});

air.NativeApplication.nativeApplication.addEventListener('exiting', function(){
	doHideAllFloat();
	nameSpace.saveFloating = false;
});


// =========================================
// =============== SETTINGS ================
// =========================================
// ------------ setSettings ------------
function setSettings(){
	var stLocal					= {};

	// local screen settings
	stLocal.screenBounds		= air.Screen.mainScreen.bounds;
	// sreen settings
	nameSpace.screen			= {};
	nameSpace.screen.width		= stLocal.screenBounds.width;
	nameSpace.screen.height		= stLocal.screenBounds.height;
	// current div
	nameSpace.currentDiv		= '';
	// user session
	nameSpace.loginUser			= {};
	// shifd settings
	nameSpace.shifd				= {};
	nameSpace.shifd.URL			= 'http://www.shifd.com/api/';
	// version settings
	nameSpace.version			= {};
	nameSpace.version.version	= '0.9.00';
	nameSpace.version.fileName	= 'updater.txt';
	//nameSpace.version.fileName	= 'version.xml';
	// links
	nameSpace.links				= {};
	//nameSpace.links.version		= 'http://dev.ichameleongroup.com/lior/shifd/';
	nameSpace.links.version		= 'http://www.shifd.com/air/';
	nameSpace.links.archive		= 'http://shifd.com/archives';
	// html cache
	nameSpace.htmlCache			= {};
	// main wondow
	nameSpace.main				= {};
	nameSpace.main.width		= window.nativeWindow.width;
	nameSpace.main.height		= window.nativeWindow.height;
	nameSpace.main.defaultX		= nameSpace.screen.width - nameSpace.main.width;
	nameSpace.main.defaultY		= ( nameSpace.screen.height - nameSpace.main.height ) / 2;
	nameSpace.main.minSize		= window.nativeWindow.minSize;
	nameSpace.main.maxSize		= window.nativeWindow.maxSize;
	// resize wondow
	nameSpace.resizeWindow		= {};
	// login
	nameSpace.login				= {};
	nameSpace.login.width		= 450;
	nameSpace.login.height		= 290;
	nameSpace.login.defaultX	= ( nameSpace.screen.width - nameSpace.login.width ) / 2;
	nameSpace.login.defaultY	= ( nameSpace.screen.height - nameSpace.login.height ) / 2;
	// adder options
	nameSpace.adder				= {};
	nameSpace.adder.optionsShow	= 0;
	nameSpace.adder.guessedCat	= 0;
	// notes options
	nameSpace.notes				= {};
	nameSpace.notes.stArchive	= {};
	nameSpace.containerVisible	= 'notesBody';
	// notes area
	nameSpace.noteArea			= {};
	// floating notes info
	nameSpace.noteInfo			= {};
	nameSpace.noteInfo.width	= 255;
	nameSpace.noteInfo.height	= 150;
	nameSpace.noteInfo.defaultX	= 100;
	nameSpace.noteInfo.defaultY	= 200;
	nameSpace.noteInfo.minSize	= new air.Point(255, 150);
	nameSpace.noteInfo.defImage	= 'images/map.jpg';
	// floating notes
	nameSpace.floating			= [];
	nameSpace.floatingDrag		= '';
	nameSpace.floatTransparency = 0.5;
	// resize settings
	nameSpace.resize			= {};
	// sync settings
	nameSpace.firstSync			= false;
	nameSpace.sync				= {};
	nameSpace.sync.flags		= {};
	nameSpace.sync.onInit		= true;
	nameSpace.sync.onSave		= true;
	nameSpace.sync.minutes		= 5;
	// timeouts settings
	nameSpace.timeout			= {};
	// debug settings
	nameSpace.debug				= {};
	nameSpace.debug.enabled		= false;
	nameSpace.debug.data		= {};
	// filter settings
	nameSpace.isFiltered		= false;
}

// ------------ showTrayIcon ------------
function showTrayIcon() {
	var stLocal		= {};

	var icon = new air.Loader();
	// pc
	if( isPC() == true ){
		//air.NativeApplication.nativeApplication.autoExit = false;
		icon.contentLoaderInfo.addEventListener(air.Event.COMPLETE, function(event){
			var systray = air.NativeApplication.nativeApplication.icon;
		    systray.tooltip = "NYT Shifd";
			air.NativeApplication.nativeApplication.icon.bitmaps = [event.target.content.bitmapData];
		});
		icon.load(new air.URLRequest("logo/shifd16x16.png"));
	}

	// mac
	if( isMac() == true ){

	}
}

// ------------ setTraySettings ------------
function setTraySettings(){
	var stLocal		= {};

	var iconMenu = new air.NativeMenu();
	var OpenCommand = iconMenu.addItem(new air.NativeMenuItem("Open"));
		OpenCommand.addEventListener(air.Event.SELECT, function(event) {
			if( typeof getLoginUser().fname != 'undefined' ){
				window.nativeWindow.restore();
				window.nativeWindow.visible = true;
				window.nativeWindow.alwaysInFront = true;
				window.nativeWindow.alwaysInFront = false;
				doShowAllFloat();
			}
		});
	var exitCommand = iconMenu.addItem(new air.NativeMenuItem("Exit"));
		exitCommand.addEventListener(air.Event.SELECT, function(event) {
			air.NativeApplication.nativeApplication.icon.bitmaps = [];
			air.NativeApplication.nativeApplication.exit();
		});

	// pc
	if( isPC() == true ){
		var systray = air.NativeApplication.nativeApplication.icon;
		air.SystemTrayIcon(systray).addEventListener( window.runtime.flash.events.MouseEvent.CLICK, function(event){
			if( typeof getLoginUser().fname != 'undefined' ){
				window.nativeWindow.restore();
				window.nativeWindow.alwaysInFront = true;
				window.nativeWindow.alwaysInFront = false;
				window.nativeWindow.activate();
				doShowAllFloat();
			}
		 });
		systray.menu = iconMenu;
	}

	//for the dock icon we should add the invoke event ;)
	//this is how the dock works on mac
	//this works for windows, too
		air.NativeApplication.nativeApplication.addEventListener(air.InvokeEvent.INVOKE, function(event){
			if( typeof getLoginUser().fname != 'undefined' ){
				window.nativeWindow.restore();
				window.nativeWindow.alwaysInFront = true;
				window.nativeWindow.alwaysInFront = false;
				window.nativeWindow.activate();
				doShowAllFloat();
			}
		 });

	//mac
	if( isMac() == true ){
		var systray = air.NativeApplication.nativeApplication.icon;
		systray.menu = iconMenu;
	}
}


// =========================================
// ============= CONNECTIVITY ==============
// =========================================
// ------------ checkConnection ------------
function checkConnection(){
	nameSpace.socketMonitor = new window.runtime.air.net.URLMonitor(new air.URLRequest(nameSpace.shifd.URL));
	nameSpace.socketMonitor.addEventListener(air.StatusEvent.STATUS, checkConnectionResult);
	nameSpace.socketMonitor.start();
}

// ------------ checkConnectionResult ------------
function checkConnectionResult(){
	nameSpace.isConnected = nameSpace.socketMonitor.available;
//	trace("Status change. Current status: " + nameSpace.socketMonitor.available);
	if( nameSpace.socketMonitor.available ){
		$('#div_status_offline').hide();
		$('#div_status_online').show();
		// start sync interval
		if( typeof nameSpace.loginUser.fname != 'undefined' ){
			doSetSyncInverval();
		}
	}
	else{
		$('#div_status_online').hide();
		$('#div_status_offline').show();
		// stop sync interval
		doStopSyncInverval();
	}
}

// =========================================
// ============== VERSIONING ===============
// =========================================
// ------------ checkForVersionResponce ------------
function checkForVersionResponce(){
	if( typeof nameSpace.isNewVersion == 'undefined' ){
		_setTimeout(checkForVersionResponce, 1000 * 0.5);
	}
	else{
		if( nameSpace.isNewVersion == true ){
			if( confirm('New version available. Get it now?') ){
				getNewVersion();
			}
			else{
				showLogin();
			}
		}
		else{
			showLogin();
		}
	}
}

// =========================================
// =============== DISPLAYS ================
// =========================================
// ------------ showLogin ------------
function showLogin(){
	var stLocal								= {};

	// create loader and content pointer
	stLocal.HTMLLoader						= air.HTMLLoader;
	stLocal.htmlContent						= new air.File("app:/login.html");
	// window options
	stLocal.windowOptions					= new air.NativeWindowInitOptions();
	stLocal.windowOptions.maximizable		= false;
	stLocal.windowOptions.minimizable		= false;
	stLocal.windowOptions.resizable			= false;
	stLocal.windowOptions.systemChrome		= 'none';
	stLocal.windowOptions.transparent		= true;
	stLocal.windowOptions.type				= air.NativeWindowType.NORMAL;
	// window position and size
	stLocal.Rectangle						= new air.Rectangle( nameSpace.login.defaultX, nameSpace.login.defaultY, nameSpace.login.width, nameSpace.login.height );
	// create and show window
	stLocal.rootWindow						= stLocal.HTMLLoader.createRootWindow( true, stLocal.windowOptions, false, stLocal.Rectangle );
	nameSpace.loginWindow					= stLocal.rootWindow;
	stLocal.rootWindow.addEventListener("htmlDOMInitialize", loginWindowFunctionInjection);
	//
	nameSpace.loginWindow.window.nativeWindow.addEventListener(air.Event.CLOSING, function(e) {
		closeLogin();
	});
	stLocal.rootWindow.load( new air.URLRequest( stLocal.htmlContent.url ) );
}

// ------------ closeLogin ------------
function closeLogin(v){
	if( typeof nameSpace.loginWindow == 'object' ){
		nameSpace.loginWindow.window.controlClose(v);
	}
}

// ------------ inject fucntion to login window ------------
function loginWindowFunctionInjection(e){
	nameSpace.loginWindow.window.trace				= trace;
	nameSpace.loginWindow.window.getIsConnected		= getIsConnected;
	nameSpace.loginWindow.window.getLoginUser		= getLoginUser;
	nameSpace.loginWindow.window.sqlSessionGet		= sqlSessionGet;
	nameSpace.loginWindow.window.doLogin			= doLogin;
	nameSpace.loginWindow.window.mainControlClose	= controlClose;
	nameSpace.loginWindow.window.mainControlHide	= controlHide;
}

// ------------ showMainWindow ------------
function showMainWindow(){
	var stLocal					= {};

	setMainWindowInitParams();
	if( typeof nameSpace.main.initEvents == 'undefined' ){
		setMainWindowEvents();
	}

	window.nativeWindow.width	= nameSpace.main.width;
	window.nativeWindow.height	= nameSpace.main.height;
	window.nativeWindow.x		= nameSpace.main.defaultX;
	window.nativeWindow.y		= nameSpace.main.defaultY;

	doSetNotesSizes();

	window.nativeWindow.visible = true;
	window.nativeWindow.orderToFront();


	stLocal.showInput = getShowInput(nameSpace.loginUser.userId);
	stLocal.doShowInput = true;
	if(stLocal.showInput.success == true)
		stLocal.doShowInput = stLocal.showInput.showInput;

// 	if(stLocal.doShowInput)
// 		showInput();
// 	else
// 		hideInput();

	disableSelection(document.body);
}

// ------------ setMainWindowInitParams ------------
function setMainWindowInitParams(){
	var stLocal					= {};

	stLocal.windowParams		= sqlWindowGet('main');
	if( stLocal.windowParams.success ){
		nameSpace.main.width	= stLocal.windowParams.results.width;
		nameSpace.main.height	= stLocal.windowParams.results.height;
		nameSpace.main.defaultX	= stLocal.windowParams.results.x;
		nameSpace.main.defaultY	= stLocal.windowParams.results.y;
	}
	else{
		saveMainWindowInitParams();
	}
}

// ------------ setMainWindowEvents ------------
function setMainWindowEvents(){
	nameSpace.main.initEvents = 1;
}

// ------------ saveMainWindowInitParams ------------
function saveMainWindowInitParams(){
	nameSpace.main.width	= window.nativeWindow.width;
	nameSpace.main.height	= window.nativeWindow.height;
	nameSpace.main.defaultX	= window.nativeWindow.x;
	nameSpace.main.defaultY	= window.nativeWindow.y;
	sqlSaveWindow( 'main', window.nativeWindow.width, window.nativeWindow.height, window.nativeWindow.x, window.nativeWindow.y );
}

// ------------ hideMainWindow ------------
function hideMainWindow(){
	window.nativeWindow.visible = false;
}

// ------------ doShowSyncOptions ------------
function doShowSyncOptions(){
	if( $('#syncOptions_container:visible').size() == 0 ){
		$('#syncOptions_container').show();
		doSetTimeoutHideSyncBox();
	}
	else{
		doHideSyncOptions();
	}
}

// ------------ doHideSyncOptions ------------
function doHideSyncOptions(){
	doStopTimeoutHideSyncBox();
	$('#syncOptions_container').hide();
}

// ------------ doSetTimeoutHideSyncBox ------------
function doSetTimeoutHideSyncBox(){
	doSetHideTimeout( '#syncOptions_container', 3 );
}

// ------------ doStopTimeoutHideSyncBox ------------
function doStopTimeoutHideSyncBox(){
	doStopTimeout('#syncOptions_container');
}

// ------------ showArchives ------------
function showArchives(){
	navigateToURL( nameSpace.links.archive );
}

// =========================================
// ============= USER SESSION ==============
// =========================================
// ------------ doLogin ------------
function doLogin( userName, password, remember, fnError ){
	debug('doLogin',0);
	var stReturn	= {};
	var stLocal		= {};
	var stData		= {};

	nameSpace.shouldShowFloats = false;
	nameSpace.saveFloating = true;

	stReturn.success			= true;
	stReturn.results			= '';
	stReturn.message			= 'Login successful';

	$('#filter').attr('disabled', false);

	doLoginButtonOnLogin();

	// check shifd
	if( nameSpace.isConnected == true ){
		// in shifd.js
		stLocal.shifdLogin		= shifdLogin( userName, password, onLoginCallback, {remember: remember, error:fnError});
	}
	// check local dB
	else{
		doLoginLocal( userName, password, remember );
	}

	debug('doLogin',1);
	return stReturn;
}

// ------------ onLoginCallback ------------
function onLoginCallback(info) {
		// login successful
		if (info.success) {
			info.results.password = info.password;
			// in sql.js
			sqlUserSave( info.results );
			doLoginLocal( info.username, info.password, info.extra.remember );
		}
		// login not successful
		else{
			doLoginButtonReset();
			// call error function
			info.extra.error.call(window);
		}
}
// ------------ doLoginLocal ------------
function doLoginLocal( userName, password, remember ){
	debug('doLoginLocal',0);
	var stLocal		= {};
	// in sql.js
	stLocal			= sqlUserValidate( userName, password );
	// valid user
	if( stLocal.success ){
		setSession( userName, password, remember );
		// displays
		closeLogin(true);
		showMainWindow();
		setTraySettings();
		//
		doShowNotes();
		/* MAIN PAGE ACTIONS */
		// add focus and blur events
		//$('.doFocusAndBlur').click( function(){ fieldOnFocus(this); } );
		//$('.doFocusAndBlur').focus( function(){ fieldOnFocus(this); } );
		//$('.doFocusAndBlur').blur( function(){ fieldOnBlur(this); } );
		// change add note type
		// notes view type
		$('#note_view_grid').click( function(){ noteViewType_grid( 'grid' ); } );
		$('#note_view_list').click( function(){ noteViewType_list( 'list' ); } );
		// filter
		$('#clearFilter').click(clearFilter);
		$('#filter').keypress( function(event){ doFilterNotes( event ); } );

		// sync
		$('#syncOptions_forceSync').click(doSync);
		$('#syncOptions_container').mouseover(doStopTimeoutHideSyncBox);
		$('#syncOptions_container').mouseout(doSetTimeoutHideSyncBox);
		doSetSyncInverval();
		showLastSyncDate();
	}
	// invalid user
	else{
		doAlert( stLocal.message );
		doLoginButtonReset();
	}
	debug('doLoginLocal',1);
}

// ------------ doLogout ------------
function doLogout() {
	clearTimers();
	nameSpace.loginUser = {};
	doCloseAllFloat();
	hideMainWindow();
	doAddNoteReset();
	doStopSyncInverval();
	clearFilter();
	showLogin();
}

// ------------ setSession ------------
function setSession( userName, password, remember ) {
	// in sql.js
	nameSpace.loginUser = sqlUserGet(userName).results;
	sqlSessionSet( userName, password, remember );
}

// ------------ doLoginButtonOnLogin ------------
function doLoginButtonOnLogin() {
	nameSpace.loginWindow.window.$('#btnAuth').attr('disabled',true);
	nameSpace.loginWindow.window.$('#btnAuth').val('Loging in...');
}

// ------------ doLoginButtonReset ------------
function doLoginButtonReset() {
	nameSpace.loginWindow.window.$('#btnAuth').attr( 'disabled', false);
	nameSpace.loginWindow.window.$('#btnAuth').val( nameSpace.loginWindow.window.$('#btnAuth').attr('title') );
}

// =========================================
// ============= DISPLAY NOTES =============
// =========================================
// ------------ doSetNotesSizes ------------
function doSetNotesSizes() {
	debug('doSetNotesSizes',0);
	var stLocal				= {};

	stLocal.view_type	= $('#view_type').val();

	//doCheckGridBodySrollbar();

	stLocal.controlHeight	= parseInt( $('#container_controls').css('height').replace('px','') );
	stLocal.adderHeight		= parseInt( $('#add-outer').css('height').replace('px','') );
	if(isNaN(stLocal.adderHeight)) stLocal.adderHeight = 0;
	stLocal.filterHeight	= parseInt( $('#divOptions').css('height').replace('px','') );
	stLocal.bottomHeight	= parseInt( $('#bottom-bar').css('height').replace('px','') );
	stLocal.subtractHeight	= stLocal.controlHeight + stLocal.adderHeight + stLocal.filterHeight + stLocal.bottomHeight + 105;

	stLocal.windowHeight				= window.nativeWindow.height;
	stLocal.notesHeight					= stLocal.windowHeight - ( stLocal.subtractHeight - 17 );
	stLocal.notesBodyHeight				= stLocal.windowHeight - ( 770 - stLocal.subtractHeight );
	if( isMac() ){
		stLocal.notesBodyHeight			= stLocal.notesBodyHeight + 13;
	}
//	for(var i in stLocal)
//		air.trace(" - " + i + ": " + stLocal[i]);

	// note area height
	$('#div_notes').css( 'height', stLocal.notesHeight );
	$('#div_notes_grid').css( 'height', stLocal.notesHeight );
	$('#div_notes_list').css( 'height', stLocal.notesHeight );
	// grid
	$('#placesBody, #linksBody, #notesBody').css( 'height', stLocal.notesBodyHeight );
	// list
	$('#mainConteiner_list').css( 'height', stLocal.notesHeight );

	debug('doSetNotesSizes',1);
}

// ------------ doClearNotesArea ------------
function doClearNotesArea() {
	//$('#div_notes_grid').html('');
	//$('#div_notes_list').html('');

	//this works faster
	$('#div_notes_grid').html2('');
	$('#div_notes_list').html2('');
}

// ------------ doFilterNotes ------------
function doFilterNotes( event ) {
	if( typeof event.keyCode != 'undefined' && event.keyCode == 13 ){
		if(!$('#filter').attr('disabled')) {
			if( $('#filter').val() != '' && $('#filter').val() != $('#filter').attr('title')){
				nameSpace.isFiltered = true;
				$('#search_icon_clear').show();
			} else {
				nameSpace.isFiltered = false;
				$('#search_icon_clear').hide();
			}
			doShowNotes();
		}
	}
}

// ------------ clearFilter ------------
function clearFilter() {
	if($('#filter').attr('disabled'))  {
		return;
	}
	$('#filter').val('');
	fieldOnBlur( document.getElementById('filter') );
	nameSpace.isFiltered = false;
	_setTimeout(doShowNotes, 1000 * 0.1);
}

// ------------ showNotesLoading ------------
function showNotesLoading() {
	$('#filter').attr('disabled', true);
	$('#div_notes').css('display', 'none');
	$('#div_waiting_notes').css('display', 'block');
	nameSpace.isLoadingNotes = true;
}

// ------------ hideNotesLoading ------------
function hideNotesLoading() {
	$('#div_notes').css('display', '');
	$('#div_waiting_notes').css('display', 'none');
	nameSpace.isLoadingNotes = false;
	$('#filter').attr('disabled', false);
}

// ------------ doShowNotes ------------
function doShowNotes() {
	debug('doShowNotes',0);
	var stLocal				= {};
	// current display
	stLocal.view_type		= $('#view_type').val();
	// div locations
	stLocal.gridArea		= $('#div_notes_grid');
	stLocal.listArea		= $('#div_notes_list');
	// item counts
	stLocal.countNotes		= '0';
	stLocal.countLinks		= '0';
	stLocal.countPlaces		= '0';
	// last day
	stLocal.lastNoteDay		= '';
	// clear areas
	doClearNotesArea();
	// in htmlRender.js
	stLocal.gridArea.html2( htmlGrid() );
	$("#mainConteiner").accordion({header: "div.itemHeader", autoheight: true});
	stLocal.listArea.html2( htmlList() );
	// locations inside note area
	stLocal.listContainer	= $('#mainConteiner_list');
	// set up grid acordion actions
	//$('#div_notes_grid .itemHeader').click( function(){ doShowNotes_GridBody( $(this).attr('itemBodyId') ) } );

	stLocal.groupNumber		= 1;
	stLocal.groupSize		= 0;
	stLocal.sqlFilter		= '';
	if( nameSpace.isFiltered ){
		stLocal.sqlFilter = "(content LIKE '%" + stringToSQLFormat($('#filter').val()) + "%' OR tag LIKE '%" + stringToSQLFormat($('#filter').val()) + "%' )";
	}

	// in sql.js
	stLocal.stNotes		= sqlNotesGet( nameSpace.loginUser.userId, stLocal.groupSize, stLocal.groupNumber, $('#sort_type').val(), stLocal.sqlFilter );

	// do insert notes
	if( stLocal.stNotes.results != '' ){
		showNotesLoading();

		// locations inside note area
		stLocal.notesBody			= $('#notesBody');
		stLocal.linksBody			= $('#linksBody');
		stLocal.placesBody			= $('#placesBody');

		// insert asynchronously
		stLocal.note_idx = 0;
		stLocal.finish = function () {
			doShowItemCount( 'note', stLocal.countNotes );
			doShowItemCount( 'link', stLocal.countLinks );
			doShowItemCount( 'place', stLocal.countPlaces );
			// set events
			//doSetDisplayEvents();
			doSetNotesSizes();
			// display no message containers for notes
			stLocal.elemGrid			= document.createElement( "div" );
			stLocal.elemGrid.id			= 'itemGridConteiner_noMsg_note';
			stLocal.notesBody.append( stLocal.elemGrid );
			if( stLocal.countNotes != 0 ){
				$('#itemGridConteiner_noMsg_note').hide();
			}
			$('#itemGridConteiner_noMsg_note').html2( htmlNoMsgGrid() );
			// display no message containers for links
			stLocal.elemGrid			= document.createElement( "div" );
			stLocal.elemGrid.id			= 'itemGridConteiner_noMsg_link';
			stLocal.linksBody.append( stLocal.elemGrid );
			if( stLocal.countLinks != 0 ){
				$('#itemGridConteiner_noMsg_link').hide();
			}
			$('#itemGridConteiner_noMsg_link').html2( htmlNoMsgGrid() );
			// display no message containers for places

			stLocal.elemGrid			= document.createElement( "div" );
			stLocal.elemGrid.id			= 'itemGridConteiner_noMsg_place';
			stLocal.placesBody.append( stLocal.elemGrid );
			if( stLocal.countPlaces != 0 ){
				$('#itemGridConteiner_noMsg_place').hide();
			}
			$('#itemGridConteiner_noMsg_place').html2( htmlNoMsgGrid() );

			nameSpace.shouldShowFloats = true;
			doShowAllFloat();
			hideNotesLoading();
		};
		_setTimeout(doNotesTimer, 1, stLocal)
	} else {
		nameSpace.shouldShowFloats = true;
	}

	// grid
	if( stLocal.view_type == 'grid' ){
		stLocal.gridArea.show();
	}
	// list
	else if( stLocal.view_type == 'list' ){
		stLocal.listArea.show();
	}
	doSetNotesSizes();

	debug('doShowNotes',1);
}

function doNotesTimer(stLocal) {
	if (stLocal.note_idx == stLocal.stNotes.results.length) {
		if (stLocal.finish) stLocal.finish.call(window);
		return;
	}
	// current note
	var thisNote		= stLocal.stNotes.results[stLocal.note_idx];
	// create listHeader day container
	if( stLocal.lastNoteDay != dateFormat(thisNote.dateStamp, 3) ){
		stLocal.lastNoteDay		= dateFormat(thisNote.dateStamp, 3);
		stLocal.listBody		= doCreateListHeader( thisNote.dateStamp );
	}
	// container
	stLocal.elemGrid			= document.createElement( "div" );
	stLocal.elemGrid.className	= 'itemBodyConteiner';
	stLocal.elemGrid.id			= 'itemGridConteiner_' + thisNote.noteId;
	stLocal.elemList			= document.createElement( "div" );
	stLocal.elemList.className	= 'itemBodyConteiner';
	stLocal.elemList.id			= 'itemListConteiner_' + thisNote.noteId;
	// set container
	if( thisNote.type == 'note' ){
		stLocal.countContainer	= $('#notesCount');
	}
	else if( thisNote.type == 'link' ){
		stLocal.countContainer	= $('#linksCount');
	}
	else if( thisNote.type == 'place' ){
		stLocal.countContainer	= $('#placesCount');
	}

	// set list container
	stLocal.listBody.append( stLocal.elemList );
	if( thisNote.type == 'note' ){
		stLocal.countNotes++;
		stLocal.notesBody.append( stLocal.elemGrid );
			$(stLocal.elemGrid).attr('transparency', 1);
			$(stLocal.elemList).attr('transparency', 1);
		doSetContent_note( thisNote.noteId, thisNote.content, thisNote.tag, thisNote.dateStamp, thisNote.archived );
	}
	else if( thisNote.type == 'link' ){
		stLocal.countLinks++;
		stLocal.linksBody.append( stLocal.elemGrid );
			$(stLocal.elemGrid).attr('transparency', 1);
			$(stLocal.elemList).attr('transparency', 1);
		doSetContent_link( thisNote.noteId, thisNote.content, thisNote.tag, thisNote.dateStamp, thisNote.archived );
	}
	else if( thisNote.type == 'place' ){
		stLocal.countPlaces++;
		stLocal.placesBody.append( stLocal.elemGrid );
			$(stLocal.elemGrid).attr('transparency', 1);
			$(stLocal.elemList).attr('transparency', 1);
		doSetContent_place( thisNote.noteId, thisNote.content, thisNote.tag, thisNote.image, thisNote.dateStamp, thisNote.archived );
	}
	stLocal.count = stLocal.countContainer.html2();
	stLocal.count ++;
	stLocal.countContainer.html2(stLocal.count.toString());

	if(thisNote.noteWasFloating){
		doFloatNote(thisNote.noteId);
	}

	stLocal.note_idx ++;
	_setTimeout(doNotesTimer, 1, stLocal);
}

// ------------ doShowItemCount ------------
function doShowItemCount( type, count ){
	debug('doShowItemCount ' + type + ' ' + count);
	var stLocal				= {};
	stLocal.sqlFilter		= "(type = '" + type + "') ";
	if( nameSpace.isFiltered ){
		stLocal.sqlFilter	= stLocal.sqlFilter + "AND (content LIKE '%" + stringToSQLFormat($('#filter').val()) + "%' OR tag LIKE '%" + stringToSQLFormat($('#filter').val()) + "%' ) ";
	}
	else{
		stLocal.sqlFilter	= stLocal.sqlFilter + "AND archived = 0 ";
	}

	// set container
	if( type == 'note' ){
		stLocal.countContainer	= $('#notesCount');
	}
	else if( type == 'link' ){
		stLocal.countContainer	= $('#linksCount');
	}
	else if( type == 'place' ){
		stLocal.countContainer	= $('#placesCount');
	}
	// check count
	if( typeof count == 'undefined' ){
		stLocal.stNotes		= sqlNotesGet( nameSpace.loginUser.userId, 0, 1, $('#sort_type').val(), stLocal.sqlFilter );
		count				= stLocal.stNotes.rc;
	}

	stLocal.countContainer.html2( count.toString() );
	if( count.toString() != '0' ){
		$('#itemGridConteiner_noMsg_' + type).hide();
	}
	else{
		$('#itemGridConteiner_noMsg_' + type).show();
	}
}

// ------------ doSetContentById ------------
function doSetContentById( noteId, doDisplayUpdates ) {
	var stLocal					= {};
	// get note
	stLocal.stNote				= sqlGetNote( noteId );

	// if note exists
	if( stLocal.stNote.success == true && stLocal.stNote.results.toDelete == 0 ){
		doSetItemContentById( noteId, doDisplayUpdates );
	}
}

// ------------ findItemType ------------
function deleteNoteIfTypeChanged(noteId, type) {
	var stLocal					= {};
	//
	stLocal.noteId				= '#itemGridConteiner_' + noteId;

	// locations inside note area
	stLocal.notesBody			= $('#notesBody ' + stLocal.noteId);
	stLocal.linksBody			= $('#linksBody ' + stLocal.noteId);
	stLocal.placesBody			= $('#placesBody ' + stLocal.noteId);

	if (stLocal.notesBody.length > 0) {
		if (type != 'note') {
			stLocal.notesBody.remove();
		}
	} else if (stLocal.placesBody.length > 0) {
		if (type != 'place') {
			stLocal.placesBody.remove();
		}
	} else if (stLocal.linksBody.length > 0) {
		if (type != 'link') {
			stLocal.linksBody.remove();
		}
	}
	if( typeof nameSpace.floating[noteId] != 'undefined' && typeof nameSpace.floating[noteId].window != 'undefined' ){
		nameSpace.floating[noteId].rootWindow.window.getNoteView();
		nameSpace.floating[noteId].rootWindow.window.doControlsLoad();
		nameSpace.floating[noteId].rootWindow.window.doSetNoteSizes();
		nameSpace.floating[noteId].rootWindow.window.doSetEvents();
	}

}

// ------------ doSetItemContentById ------------
function doSetItemContentById( noteId, doDisplayUpdates ) {
	var stLocal					= {};
	// get note
	stLocal.stNote				= sqlGetNote( noteId );
	// if note exists
	if( stLocal.stNote.success == true ){
		deleteNoteIfTypeChanged(noteId, stLocal.stNote.results.type);
		// check grid container
		if( document.getElementById('itemGridConteiner_' + noteId) == null ){
			doCreateItemConteiner( noteId, stLocal.stNote.results.type, 'Grid', '', stLocal.stNote );
		}
		// check list header
		if( document.getElementById('itemHeader_' + dateFormat( stLocal.stNote.results.dateStamp, 3 ).replace(/ /g, '').replace(',', '')) == null ){
			doCreateListHeader( stLocal.stNote.results.dateStamp );
		}
		// check list container
		if( document.getElementById('itemListConteiner_' + noteId) == null ){
			doCreateItemConteiner( noteId, stLocal.stNote.results.type, 'List', stLocal.stNote.results.dateStamp, stLocal.stNote );
		}
		// note
		if( stLocal.stNote.results.type == 'note' ){
			doSetContent_note( stLocal.stNote.results.noteId, stLocal.stNote.results.content, stLocal.stNote.results.tag, stLocal.stNote.results.localDateStamp, stLocal.stNote.results.archived, doDisplayUpdates );
		}
		// link
		else if( stLocal.stNote.results.type == 'link' ){
			doSetContent_link( stLocal.stNote.results.noteId, stLocal.stNote.results.content, stLocal.stNote.results.tag, stLocal.stNote.results.localDateStamp, stLocal.stNote.results.archived, doDisplayUpdates );
		}
		// place
		else if( stLocal.stNote.results.type == 'place' ){
			doSetContent_place( stLocal.stNote.results.noteId, stLocal.stNote.results.content, stLocal.stNote.results.tag, stLocal.stNote.results.image, stLocal.stNote.results.localDateStamp, stLocal.stNote.results.archived, doDisplayUpdates );
		}
	}
	//if( typeof doDisplayUpdates != 'undefined' && doDisplayUpdates == true ){
		//doSetDisplayEvents( noteId );
	//}
}

// ------------ doCreateItemConteiner ------------
function doCreateItemConteiner( noteId, type, viewType, dateStamp, note ) {
	var stLocal				= {};
	debug('doCreateItemConteiner',0);
	stLocal.elem			= document.createElement( "div" );
	stLocal.elem.className	= 'itemBodyConteiner';
	stLocal.elem.id			= 'item' + viewType + 'Conteiner_' + noteId;

	// grid
	if( viewType == 'Grid' ){
		stLocal.itemBody		= $('#' + type + 'sBody');
		if (nameSpace.firstSync == true) {
			stLocal.itemBody.prepend( stLocal.elem );
		}
		else {
			stLocal.previousNote	= sqlGetPreviousNoteByDateStamp(nameSpace.loginUser.userId, note.results.dateStamp, " AND type = '" + type + "'");
			if (stLocal.previousNote.success == true) {
				stLocal.previousNoteElem = $('#itemGridConteiner_' + stLocal.previousNote.results.noteId, stLocal.itemBody);
				if (stLocal.previousNoteElem.length > 0) {
					stLocal.previousNoteElem.after(stLocal.elem);
				} else {
					stLocal.itemBody.prepend( stLocal.elem );
				}
			} else {
				stLocal.itemBody.prepend( stLocal.elem );
			}
		}
	}
	// list
	else{
		stLocal.headerId		= dateFormat( dateStamp, 3 ).replace(/ /g, '').replace(',', '');
		if (nameSpace.firstSync == true) {
			 $('#itemHeader_' + stLocal.headerId +'>.displayListHeader').after(stLocal.elem);
		}
		else {
			stLocal.previousNote	= sqlGetPreviousNoteByDateStamp(nameSpace.loginUser.userId, note.results.dateStamp, '');
			if (stLocal.previousNote.success) {
				stLocal.previousNoteElem = $('#itemGridConteiner_' + stLocal.previousNote.results.noteId, stLocal.headerId);
				if (stLocal.previousNoteElem.length > 0) {
					stLocal.previousNoteElem.after(stLocal.elem);
				} else {
					 $('#itemHeader_' + stLocal.headerId +'>.displayListHeader').after(stLocal.elem);
				}
			} else {
				 $('#itemHeader_' + stLocal.headerId +'>.displayListHeader').after(stLocal.elem);
			}
		}

	}
	$('#item' + viewType + 'Conteiner_' + noteId).attr('transparency', 1);
	if (!nameSpace.isLoadingNotes) $('#' + stLocal.elem.id).hide();
	debug('doCreateItemConteiner',1);
}

// ------------ doCreateListHeader ------------
function doCreateListHeader( dateStamp ) {
	var stLocal						= {};
	debug('doCreateListHeader',0);
	stLocal.headerId					= dateFormat( dateStamp, 3 ).replace(/ /g, '').replace(',', '');
	stLocal.elemListHeader				= document.createElement( "div" );
	stLocal.elemListHeader.className	= 'itemHeaderConteiner';
	stLocal.elemListHeader.id			= 'itemHeader_' + stLocal.headerId;

	stLocal.headerInserted		= false;
	// search for curent dates and insert
	$("#mainConteiner_list .itemHeaderConteiner").each(
		function(){
			if( stLocal.headerInserted == false && $(this).attr('date') < dateStamp.substring(0,10) ){
				$(this).before( stLocal.elemListHeader );
				stLocal.headerInserted = true;
			}
		}
	);
	// if not inserted, append at the end
	if( stLocal.headerInserted == false ){
		$('#mainConteiner_list').append( stLocal.elemListHeader );
	}
	// set html and attritube
	$('#itemHeader_' + stLocal.headerId).html2( htmlListHeader( dateFormat( dateStamp, 3 ) ) );
	$('#itemHeader_' + stLocal.headerId).attr('date', dateStamp.substring(0,10) );

	return $('#itemHeader_' + stLocal.headerId);

	debug('doCreateListHeader',1);
}

// ------------ doShowCreateItemConteiner ------------
function doShowCreateItemConteiner( containerId, doDisplayUpdates ) {
	//do not fade in while loading - waiting indicator makes the effect invisible
	if(nameSpace.isLoadingNotes) return;

	if( $( containerId ).size() == 1 && $( containerId + ':visible').size() == 0 ){
		$( containerId ).fadeIn("slow");
		/*if( typeof doDisplayUpdates != 'undefined' && doDisplayUpdates == true ){
			doSetNotesSizes();
		}*/
	}
}

// ------------ doSetContent_note ------------
function doSetContent_note( noteId, content, tag, dateStamp, archived, doDisplayUpdates ) {
	// in htmlRender.js
	var stLocal = {};

	$('#itemGridConteiner_' + noteId).html2( htmlNoteGrid( noteId, content, tag, dateStamp, archived ) );
	$('#itemListConteiner_' + noteId).attr('time', dateStamp ).html2( htmlNoteList( noteId, content, tag, dateStamp, archived ) );

	if( archived == true ){
		$('.noteDelete','#itemGridConteiner_' + noteId).attr('tooltip', 'Delete');
		$('#itemGridConteiner_' + noteId).attr('isArchived', 1);
		$('#itemListConteiner_' + noteId).attr('isArchived', 1);
		$('#grid_displayGrid_collapsed_' + noteId).removeClass('displayNote').addClass('displayArchive');
		$('#grid_displayGrid_expanded_' + noteId).removeClass('displayNote').addClass('displayArchive');
	}
	if( typeof nameSpace.floating[noteId] != 'undefined' && typeof nameSpace.floating[noteId].window != 'undefined' ){
		doSetNoteTransparency( noteId, nameSpace.floatTransparency );
		$('#itemGridConteiner_'+noteId+' .icon_float_' + noteId+', #itemListConteiner_'+noteId+' .icon_float_' + noteId).hide();
		$('#itemGridConteiner_'+noteId+' .icon_dock_' + noteId+', #itemListConteiner_'+noteId+' .icon_dock_' + noteId).show();
	}
	if (!isFiltered(content, tag)) {
		doShowCreateItemConteiner( '#itemGridConteiner_' + noteId, doDisplayUpdates );
		doShowCreateItemConteiner( '#itemListConteiner_' + noteId, doDisplayUpdates );
	}
	if( typeof doDisplayUpdates != 'undefined' && doDisplayUpdates == true ){
		doShowItemCount('note');
	}
}

// ------------ doSetContent_link ------------
function doSetContent_link( noteId, content, tag, dateStamp, archived, doDisplayUpdates ) {
	// in htmlRender.js
	$('#itemGridConteiner_' + noteId).html2(htmlLinkGrid( noteId, content, tag, dateStamp, archived ) );
	$('#itemListConteiner_' + noteId).attr('time', dateStamp ).html2( htmlLinkList( noteId, content, tag, dateStamp, archived ) );
	if( archived == true ){
		$('.noteDelete','#itemGridConteiner_' + noteId).attr('tooltip', 'Delete');
		$('#grid_displayGrid_collapsed_' + noteId).removeClass('displayLink').addClass('displayArchive');
		$('#grid_displayGrid_expanded_' + noteId).removeClass('displayLink').addClass('displayArchive');
	}
	if( typeof nameSpace.floating[noteId] != 'undefined' && typeof nameSpace.floating[noteId].window != 'undefined' ){
		doSetNoteTransparency( noteId, nameSpace.floatTransparency );
		$('#itemGridConteiner_'+noteId+' .icon_float_' + noteId+', #itemListConteiner_'+noteId+' .icon_float_' + noteId).hide();
		$('#itemGridConteiner_'+noteId+' .icon_dock_' + noteId+', #itemListConteiner_'+noteId+' .icon_dock_' + noteId).show();
	}
	if (!isFiltered(content, tag)) {
		doShowCreateItemConteiner( '#itemGridConteiner_' + noteId );
		doShowCreateItemConteiner( '#itemListConteiner_' + noteId );
	}
	if( typeof doDisplayUpdates != 'undefined' && doDisplayUpdates == true ){
		doShowItemCount('link');
	}
}

// ------------ doSetContent_place ------------
function doSetContent_place( noteId, content, tag, image, dateStamp, archived, doDisplayUpdates ) {
	// in htmlRender.js
	$('#itemGridConteiner_' + noteId).html2( htmlPlaceGrid( noteId, content, tag, image, dateStamp, archived ) );
	$('#itemListConteiner_' + noteId).attr('time', dateStamp ).html2( htmlPlaceList( noteId, content, tag, image, dateStamp, archived ) );
	if( archived == true ){
		$('.noteDelete','#itemGridConteiner_' + noteId).attr('tooltip', 'Delete');
		$('#grid_displayGrid_collapsed_' + noteId).removeClass('displayPlace').addClass('displayArchive');
		$('#grid_displayGrid_expanded_' + noteId).removeClass('displayPlace').addClass('displayArchive');
	}
	if( typeof nameSpace.floating[noteId] != 'undefined' && typeof nameSpace.floating[noteId].window != 'undefined' ){
		doSetNoteTransparency( noteId, nameSpace.floatTransparency );
		$('#itemGridConteiner_'+noteId+' .icon_float_' + noteId+', #itemListConteiner_'+noteId+' .icon_float_' + noteId).hide();
		$('#itemGridConteiner_'+noteId+' .icon_dock_' + noteId+', #itemListConteiner_'+noteId+' .icon_dock_' + noteId).show();
	}
	if (!isFiltered(content, tag)) {
		doShowCreateItemConteiner( '#itemGridConteiner_' + noteId );
		doShowCreateItemConteiner( '#itemListConteiner_' + noteId );
	}
	if( typeof doDisplayUpdates != 'undefined' && doDisplayUpdates == true ){
		doShowItemCount('place');
	}
}

// ------------ doShowNotes_GridBody ------------
function doShowNotes_GridBody( itemBodyId ) {
/*	if( nameSpace.containerVisible != itemBodyId ){
		$('#' + nameSpace.containerVisible).slideUp();
		$('#' + itemBodyId).slideDown();
		nameSpace.containerVisible = itemBodyId;
		doCheckGridBodySrollbar();
	}*/
	if( $('#view_type').val() == 'grid' ) {
		$("#mainConteiner").accordion('activate',$("#mainConteiner>div."+itemBodyId+">div.itemHeader"));
		doCheckGridBodySrollbar();
	}
}

// ------------ doDisplayItemExpand ------------
function doDisplayItemExpand( noteId ) {
	var stLocal				= {};

	debug('doExpand',0);
	if( $('#view_type').val() == 'grid' ){
		stLocal.container	= '#div_notes_grid';
		stLocal.type		= 'Grid';
	}
	else{
		stLocal.container	= '#div_notes_list';
		stLocal.type		= 'List';
	}

	$( '#'+ stLocal.type.toLowerCase() + '_display' + stLocal.type + '_collapsed_container_' + noteId).hide();
	$( '#'+ stLocal.type.toLowerCase() + '_display' + stLocal.type + '_expanded_container_' + noteId).show();
	doCheckGridBodySrollbar();

	debug('doExpand',1);
}

// ------------ doDisplayItemCollapse ------------
function doDisplayItemCollapse( noteId ) {
	var stLocal		= {};

	debug('doCollapse',0);
	if( $('#view_type').val() == 'grid' ){
		stLocal.container	= '#div_notes_grid';
		stLocal.type		= 'Grid';
	}
	else{
		stLocal.container	= '#div_notes_list';
		stLocal.type		= 'List';
	}

	$( '#'+ stLocal.type.toLowerCase() + '_display' + stLocal.type + '_expanded_container_' + noteId).hide();
	$( '#'+ stLocal.type.toLowerCase() + '_display' + stLocal.type + '_collapsed_container_' + noteId).show();
	doCheckGridBodySrollbar();

	_setTimeout(function(){doCancelEditNote( noteId );}, 1000 * 0.1);

	debug('doCollapse',1);
}

// ------------ doCheckGridBodySrollbar ------------
function doCheckGridBodySrollbar() {
	var stLocal				= {};

	debug('doCheckScroll',0);
	/*stLocal.notearea		= document.getElementById(nameSpace.containerVisible);

	if( stLocal.notearea.style.height.replace('px', '') < stLocal.notearea.scrollHeight ){
		$('#' + nameSpace.containerVisible).addClass('paddingRight4');
	}
	else{
		$('#' + nameSpace.containerVisible).removeClass('paddingRight4');
	}*/

	debug('doCheckScroll',1);
}

// ------------ noteViewType_grid ------------
function noteViewType_grid(type){
	if( $('#div_notes_grid:visible').size() == 0 ){
		// set type
		$('#view_type').val( type );
		// styles
		$('#note_view_list').removeClass('noteViewType_active');
		$('#note_view_list').addClass('noteViewType_inactive');
		$('#note_view_grid').removeClass('noteViewType_inactive');
		$('#note_view_grid').addClass('noteViewType_active');
		// show notes
		//doSetNotesSizes();
		$('#div_notes_list').fadeOut( 'fast', function(){ $('#div_notes_grid').fadeIn('fast') } );
	}
}

// ------------ noteViewType_list ------------
function noteViewType_list(type){
	if( $('#div_notes_list:visible').size() == 0 ){
		// set type
		$('#view_type').val(type);
		// styles
		$('#note_view_grid').removeClass('noteViewType_active');
		$('#note_view_grid').addClass('noteViewType_inactive');
		$('#note_view_list').removeClass('noteViewType_inactive');
		$('#note_view_list').addClass('noteViewType_active');
		// show notes
		//doSetNotesSizes();
		$('#div_notes_grid').fadeOut( 'fast', function(){ $('#div_notes_list').fadeIn('fast') } );
	}
}

// ------------ setNoteMouseDown ------------
function setNoteMouseDown( noteId, event ){
	nameSpace.floatingDrag			= {};
	nameSpace.floatingDrag.id		= noteId;
	nameSpace.floatingDrag.x		= event.pageX;
	nameSpace.floatingDrag.y		= event.pageY;
}

// ------------ setNoteMouseMove ------------
function setNoteMouseMove( noteId, event ){
	var stLocal					= {};

	/*if( typeof nameSpace.floating[noteId] != 'undefined' ){
		if( typeof nameSpace.floating[noteId].window != 'undefined' ){
			nameSpace.floating[noteId].window.x	= event.pageX;
			nameSpace.floating[noteId].window.y	= event.pageY;
		}
	}
	else{
		if( noteId == nameSpace.floatingDrag.id ){
			stLocal.distanceMoved	= Math.abs(event.pageX - nameSpace.floatingDrag.x) + Math.abs( event.pageY - nameSpace.floatingDrag.y );
			if( stLocal.distanceMoved > 10 ){
				// get coordinates
				stLocal.x = window.nativeWindow.x + event.pageX - 100;
				stLocal.y = window.nativeWindow.y + event.pageY - 15;
				// open note
				doCloseFloatNote( noteId );
				doFloatNote( noteId, stLocal.x, stLocal.y, 0, 0, 1 );
				doMoveFloatNote( noteId );
				clearNoteMouseUp();
			}
		}
	}*/

	if( noteId == nameSpace.floatingDrag.id ){
		stLocal.distanceMoved	= Math.abs(event.pageX - nameSpace.floatingDrag.x) + Math.abs( event.pageY - nameSpace.floatingDrag.y );
		if( stLocal.distanceMoved > 10 ){
			// get coordinates
			stLocal.globalMousePos = getScreenMousePosition();
			stLocal.x = stLocal.globalMousePos.x - 100;
			stLocal.y = stLocal.globalMousePos.y - 15;
			// open note
			//doCloseFloatNote( noteId );
			doFloatNote( noteId, stLocal.x, stLocal.y, 0, 0, 1 );
			doMoveFloatNote( noteId );
			clearNoteMouseUp();
		}
	}
}

// ------------ clearNoteMouseUp ------------
function clearNoteMouseUp(){
	nameSpace.floatingDrag		= '';
	nameSpace.floatingDrag.id	= '';
}

// =========================================
// =============== ADD NOTES ===============
// =========================================
// ------------ doAddNoteReset ------------
function doAddNoteReset(){
	$('#tag').val('');
	fieldOnBlur( document.getElementById('tag') );
	$('#note').val('');
	fieldOnBlur( document.getElementById('note') );
	noteOnKeyUp( document.getElementById('note') );
	noteTypeChange('note');
	$('#noteAddOptionsContainer .noteAddOptions').hide();
	nameSpace.adder.optionsShow = 0;
}

// ------------ noteTypeChange ------------
function noteTypeChange(type){
	// change class of selected type tab
	$('#noteAddOptionsContainer .itemType').each( function(){ if( $(this).attr('title') == type ){ $(this).removeClass('itemType_unselected'); $(this).addClass('itemType_selected'); }else{ $(this).removeClass('itemType_selected'); $(this).addClass('itemType_unselected'); } } );
	// change value of input type
	$('#type').val(type);
	//
	if( type == 'note' ){
		nameSpace.adder.guessedCat	= 0;
	}
	else{
		nameSpace.adder.guessedCat	= 1;
	}
}

// ------------ noteOnKeyUp ------------
function noteOnKeyUp( fieldNote ){
	debug('textareakeyup',0);
	if( fieldNote.value == '' ){
		nameSpace.adder.optionsShow = 0;
		$('#noteAddOptionsContainer .noteAddOptions').hide();
		noteTypeChange('note');
	}
	else{
		if( nameSpace.adder.optionsShow == 0 ){
			nameSpace.adder.optionsShow = 1;
			_setTimeout( function(){ $('#noteAddOptionsNote').fadeIn(); $('#noteAddOptionsPlace').fadeIn(); $('#noteAddOptionsLink').fadeIn(); $('#tagLabel').fadeIn(); $('#tagInput').fadeIn(); }, 1000 * 0.1);
		}
		// in udf.js
		if( nameSpace.adder.guessedCat == 0 ){
			guess_the_category();
		}
	}
	debug('textareakeyup',1);
}

// ------------ doAddNote ------------
function doAddNote(){
	debug('doAddNote',0);
	var stLocal	= {};

	stLocal.userId		= nameSpace.loginUser.userId;
	stLocal.type		= $('#type').val();
	if( $('#note').val() == $('#note').attr('title') ){
		doAlert('Please enter a note');
		return 0;
	}
	stLocal.content		= $('#note').val();
	if( $('#tag').val() != $('#tag').attr('title') ){
		stLocal.tag		= $('#tag').val();
	}
	else{
		stLocal.tag		= '';
	}
	// in sql.js
	stLocal.stNote		= sqlNoteSave( stLocal );
	doAddNoteReset();
	if( stLocal.stNote.success == true ){
		doShowNotes_GridBody( stLocal.type + 'sContainer' );
		_setTimeout( function(){ doSetContentById( stLocal.stNote.results, true ) }, 1000 * 0.5 );
		if( nameSpace.sync.onSave ){
			_setTimeout( function(){ syncSend(stLocal.stNote.results) }, 1000 * 1.5 );
		}
	}
	debug('doAddNote',1);
}

// ------------ isFiltered ------------
function isFiltered(content, tag) {
// removing this return will make the application ALWAYS show on the view only what matches the filter
// This applies to newly added notes from the application or from the site
	return false;

	var stLocal 			= {};

	stLocal.matched			= false;
	if( nameSpace.isFiltered ){
		stLocal.filter 		= $('#filter').val();
		stLocal.re			= new RegExp(stLocal.filter, "i");
		stLocal.matched 	= (content == undefined ? false : !!stLocal.re.exec(content)) || (tag == undefined ? false : !!stLocal.re.exec(tag));
	}
	return stLocal.matched;
}

// =========================================
// ============ NOTES OPTIONS ==============
// =========================================
// ------------ doShowNoteOptions ------------
function doShowNoteOptions( noteId ){
	var stLocal		= {};

	if( $('#view_type').val() == 'grid' ){
		if( $('#itemGridConteiner_' + noteId).attr('transparency') == 1 ){
			if( $('#grid_share-box-holder_' + noteId + ':visible').size() == 0 ){
				doDisplayItemExpand( noteId );
				$('#grid_share-box-holder_' + noteId).show();
				$('#grid_share-box-holder_' + noteId).show();
				doSetHideTimeout( '#grid_share-box-holder_' + noteId, 5 );
			}
			else{
				doHideNoteOptions( noteId );
			}
		}
	}
	else{
		if( $('#itemListConteiner_' + noteId).attr('transparency') == 1 ){
			if( $('#list_share-box-holder_' + noteId + ':visible').size() == 0 ){
				$('#list_share-box-holder_' + noteId).show();
				doSetHideTimeout( '#list_share-box-holder_' + noteId, 5 );
			}
			else{
				doHideNoteOptions( noteId );
			}
		}
	}
}

// ------------ doHideNoteOptions ------------
function doHideNoteOptions( noteId ){
	var stLocal				= {};

	if( $('#view_type').val() == 'grid' ){
		stLocal.container	= '#div_notes_grid';
		stLocal.type = "Grid";
	}
	else{
		stLocal.container	= '#div_notes_list';
		stLocal.type = "List";
	}

	$( '#'+ stLocal.type.toLowerCase() +'_share-box-holder_' + noteId).hide();
}

// ------------ doSearchGoogle ------------
function doSearchGoogle( noteId ){
	var stLocal		= {};

	stLocal.URL		= 'http://www.google.com/search?q=' + document.getElementById('grid_contentOriginal_' + noteId).value;
	// in udf.js
	navigateToURL( stLocal.URL );
}

// ------------ doSearchYahoo ------------
function doSearchYahoo( noteId ){
	var stLocal		= {};

	stLocal.URL		= 'http://search.yahoo.com/search?p=' + document.getElementById('grid_contentOriginal_' + noteId).value;
	// in udf.js
	navigateToURL( stLocal.URL );
}

// ------------ doMapGoogle ------------
function doMapGoogle( content ){
	var stLocal		= {};

	stLocal.URL		= 'http://maps.google.com/maps?q=' + content;
	// in udf.js
	navigateToURL( stLocal.URL );
}

// ------------ doMapYahoo ------------
function doMapYahoo( content ){
	var stLocal		= {};

	stLocal.URL		= 'http://maps.yahoo.com/#q1=' + content;
	// in udf.js
	navigateToURL( stLocal.URL );
}

// ------------ doShareDelicious ------------
function doShareDelicious( content ){
	var stLocal		= {};

	stLocal.URL		= 'http://del.icio.us/post?url=' + content;
	// in udf.js
	navigateToURL( stLocal.URL );
}

// ------------ doShareDigg ------------
function doShareDigg( content ){
	var stLocal		= {};

	stLocal.URL		= 'http://digg.com/submit?phase=2&url=' + content;
	// in udf.js
	navigateToURL( stLocal.URL );
}

// ------------ doShareReddit ------------
function doShareReddit( content ){
	var stLocal		= {};

	stLocal.URL		= 'http://reddit.com/submit?url=' + content;
	// in udf.js
	navigateToURL( stLocal.URL );
}

// ------------ doShareNewsvine ------------
function doShareNewsvine( content ){
	var stLocal		= {};

	stLocal.URL		= 'http://www.newsvine.com/_tools/seed&save?u=' + content;
	// in udf.js
	navigateToURL( stLocal.URL );
}

// ------------ doShareFacebook ------------
function doShareFacebook( content ){
	var stLocal		= {};

	stLocal.URL		= 'http://www.facebook.com/sharer.php?u=' + content;
	// in udf.js
	navigateToURL( stLocal.URL );
}

// =========================================
// ============== EDIT NOTES ===============
// =========================================
// ------------ doEditNote ------------
function doEditNote( noteId ){
	var stLocal					= {};

	if( $('#itemGridConteiner_' + noteId).attr('transparency') == 1 ){
		if( $('#view_type').val() == 'grid' ){
			stLocal.container	= '#div_notes_grid';
			stLocal.type = "Grid";
		}
		else{
			stLocal.container	= '#div_notes_list';
			stLocal.type = "List";
		}
		$( '#'+ stLocal.type.toLowerCase() +'_viewContent_' + noteId).hide();
		$( '#'+ stLocal.type.toLowerCase() +'_editContent_' + noteId).show();
		$( '#'+ stLocal.type.toLowerCase() +'_viewTag_' + noteId).hide();
		$( '#'+ stLocal.type.toLowerCase() +'_editTag_' + noteId).show();
		$( '#'+ stLocal.type.toLowerCase() +'_content_' + noteId).val( $( '#'+ stLocal.type.toLowerCase() +'_contentOriginal_' + noteId).val() );
		$( '#'+ stLocal.type.toLowerCase() +'_content_' + noteId).focus();
		$( '#'+ stLocal.type.toLowerCase() +'_tag_' + noteId).val( $( '#'+ stLocal.type.toLowerCase() +'_tag_' + noteId).attr('currentValue') );

	}
}

// ------------ doCancelEditNote ------------
function doCancelEditNote( noteId ){
	var stLocal					= {};

	if( $('#view_type').val() == 'grid' ){
		stLocal.container	= '#div_notes_grid';
		stLocal.type = "Grid";
	}
	else{
		stLocal.container	= '#div_notes_list';
		stLocal.type = "List";
	}
	$( '#'+ stLocal.type.toLowerCase() +'_editContent_' + noteId).hide();
	$( '#'+ stLocal.type.toLowerCase() +'_viewContent_' + noteId).show();
	$( '#'+ stLocal.type.toLowerCase() +'_editTag_' + noteId).hide();
	$( '#'+ stLocal.type.toLowerCase() +'_viewTag_' + noteId).show();
}

// ------------ doSaveEditNoteById ------------
function doSaveEditNoteById( noteId ){
	var stLocal 	= {};

	if( $('#itemGridConteiner_' + noteId).attr('transparency') == 1 ){
		if( $('#view_type').val() == 'grid' ){
			stLocal.container	= '#div_notes_grid';
			stLocal.type = "Grid";
		}
		else{
			stLocal.container	= '#div_notes_list';
			stLocal.type = "List";
		}

		stLocal.content		= $( '#'+ stLocal.type.toLowerCase() +'_content_' + noteId).val();
		if( $( '#'+ stLocal.type.toLowerCase() +'tag_' + noteId).val() != $( '#'+ stLocal.type.toLowerCase() +'_tag_' + noteId).attr('title') ){
			stLocal.tag		= $( '#'+ stLocal.type.toLowerCase() +'_tag_' + noteId).val();
		}
		else{
			stLocal.tag		= '';
		}

		doSaveEditNote( noteId, stLocal.content, stLocal.tag );
	}
}

// ------------ doSaveEditNote ------------
function doSaveEditNote( noteId, content, tag ){
	var stLocal = {};

	if( $('#view_type').val() == 'grid' ){
		stLocal.container	= '#div_notes_grid';
		stLocal.type		= 'Grid';
	}
	else{
		stLocal.container	= '#div_notes_list';
		stLocal.type		= 'List';
	}

	stLocal.stSaveNote			= {};
	stLocal.stSaveNote.noteId	= noteId;
	stLocal.stSaveNote.content	= content;
	stLocal.stSaveNote.tag		= tag;
	stLocal.stSaveNote.toUpdate	= 1;
	stLocal.doExpand			= $( '#'+ stLocal.type.toLowerCase() + '_display' + stLocal.type + '_expanded_' + noteId + ':visible').size();

	// in sql.js
	sqlNoteSave( stLocal.stSaveNote );
	// save
	$( '#'+ stLocal.type.toLowerCase() +'_editTag_' + noteId).hide();
	$( '#grid_displayGrid_content_' + noteId).hide();
	$( '#list_displayList_content_' + noteId).hide();
	$( '#grid_saving_' + noteId).show();
	$( '#list_saving_' + noteId).show();
	doCallFloatNoteShowSaving( noteId );
	_setTimeout( function(){
		doSetContentById( noteId, true );
		if(stLocal.doExpand == 1){
			doDisplayItemExpand( noteId )
		};
		doRefreshFloatNote( noteId )
	}, 1000 * 2 );
	if( nameSpace.sync.onSave ){
		_setTimeout( syncSend( noteId ), 1000 * 1 );
	}
}


// =========================================
// ============= DELETE NOTES ==============
// =========================================
// ------------ doShowArchiveBox ------------
/*function doShowArchiveBox( noteId ){
	var stLocal		= {};

	dogrid_displayGridExpant( noteId );
	if( $('#archive-box-holder_' + noteId + ':visible').size() == 0 ){
		$('#archive-box-holder_' + noteId).show();
		doSetTimeoutHideArchiveBox( noteId );
	}
	else{
		doHideArchiveBox( noteId );
	}
}*/

// ------------ doSetTimeoutHideArchiveBox ------------
function doSetTimeoutHideArchiveBox( noteId ){
	nameSpace.notes.stArchive[noteId]			= {};
	nameSpace.notes.stArchive[noteId].timeoutId = _setTimeout( function(){ doHideArchiveBox( noteId ) }, 1000 * 3 );
}

// ------------ doStopTimeoutHideArchiveBox ------------
function doStopTimeoutHideArchiveBox( noteId ){
	try{
		_clearInterval( nameSpace.notes.stArchive[noteId].timeoutId );
	}
	catch(e){}
}

// ------------ doHideArchiveBox ------------
function doHideArchiveBox( noteId ){
	$('#archive-box-holder_' + noteId).hide();
}

// ------------ doDeleteOrArchiveNote ------------
function doDeleteOrArchiveNote( noteId, archive, event, isFloat ){
	if( isFloat == true || $('#itemGridConteiner_' + noteId).attr('transparency') == 1 ){
		// delete
		if( archive == 1 ){
			doDeleteNote( noteId, event )
		}
		// archive
		else{
			doArchiveNote( noteId, event )
		}
	}
}

// ------------ doDeleteNote ------------
function doDeleteNote( noteId, event ){
	if( confirm('Are you sure you want to permanently delete this item?') ){
		doDeleteNoteAction( noteId, 1, true );
	}
}

// ------------ doArchiveNote ------------
function doArchiveNote( noteId, event ){
	if( typeof event != 'undefined' && nameSpace.loginUser.firstTimeArchiving == true ){
		doAlert('This will be saved to your archive, accessible by search');
		nameSpace.loginUser.firstTimeArchiving = false;
		sqlUserSave(nameSpace.loginUser);
	}
	doDeleteNoteAction( noteId, 0, true );
}

// ------------ doDeleteNoteAction ------------
function doDeleteNoteAction( noteId, isDeleted, doCallSync ){
	var stLocal 	= {};

	stLocal.stNote	= sqlGetNote( noteId );

	doCallFloatNoteCloseControl( noteId );
	if( stLocal.stNote.success ){
		// in sql.js
		// delete
		if( isDeleted == 1 || isDeleted == 2 ){
			stLocal.text	= 'This item has been permanently deleted.';
			if( isDeleted == 1 ){
				sqlNoteSetToDelete( noteId );
			}
			else{
				sqlNoteDelete( noteId );
			}
		}
		// archive
		else{
			stLocal.text	= 'This item has been saved to your archive.';
			stLocal.stSaveNote			= {};
			stLocal.stSaveNote.noteId	= noteId;
			stLocal.stSaveNote.archived	= 1;
			sqlNoteSave( stLocal.stSaveNote );
		}
		doShowItemCount( stLocal.stNote.results.type );

		// grid
		if( $('#grid_displayGrid_collapsed_container_' + noteId + ':visible').size() != 0 ){
			$('#grid_displayGrid_collapsed_' + noteId).fadeOut("fast", function(){
				$('#itemGridConteiner_' + noteId + ' .displayGrid_collapsed .delete-box')
				.html2(stLocal.text);
				$('#itemGridConteiner_' + noteId + ' .displayGrid_collapsed .delete-box_container')
				.fadeIn('normal', function(){
					_setTimeout( function(){ fade_and_remove('#itemGridConteiner_' + noteId, isDeleted); if( doCallSync == true ){ _setTimeout( function(){ syncSend( noteId ) }, 1000 ); } }, 1000 * 2 );
				});
			} );
		}
		else{
			$('#grid_displayGrid_expanded_' + noteId).fadeOut("fast", function(){
				$('#itemGridConteiner_' + noteId + ' .displayGrid_expanded .delete-box')
				.html2(stLocal.text);
				$('#itemGridConteiner_' + noteId + ' .displayGrid_expanded .delete-box_container')
				.fadeIn('normal', function(){
					_setTimeout( function(){ fade_and_remove('#itemGridConteiner_' + noteId, isDeleted); if( doCallSync == true ){ _setTimeout( function(){ syncSend( noteId ) }, 1000 ); } }, 1000 * 2 );
				});
			} );
		}
		//list
		if( $('#list_displayList_collapsed_container_' + noteId + ':visible').size() != 0 ){
			$('#list_displayList_collapsed_' + noteId).fadeOut("fast", function(){
				$('#itemListConteiner_' + noteId + ' .displayList_collapsed .delete-box')
				.html2(stLocal.text);
				$('#itemListConteiner_' + noteId + ' .displayList_collapsed .delete-box_container')
				.fadeIn('normal', function(){
					_setTimeout( function(){ fade_and_remove('#itemListConteiner_' + noteId, isDeleted); if( doCallSync == true ){ _setTimeout( function(){ syncSend( noteId ) }, 1000 ); } }, 1000 * 2 );
				});
			} );
		}
		else{
			$('#list_displayList_expanded_' + noteId).fadeOut("fast", function(){
				$('#itemListConteiner_' + noteId + ' .displayList_expanded .delete-box')
				.html2(stLocal.text);
				$('#itemListConteiner_' + noteId + ' .displayList_expanded .delete-box_container')
				.fadeIn('normal', function(){
					_setTimeout( function(){ fade_and_remove('#itemListConteiner_' + noteId, isDeleted); if( doCallSync == true ){ _setTimeout( function(){ syncSend( noteId ) }, 1000 ); } }, 1000 * 2 );
				});
			} );
		}
	}
}

// ------------ fade_and_remove ------------
function fade_and_remove(selector, isDeleted) {
	// dont remove archived from arhicved area
	if( isDeleted == 0 ){
		$(selector + ':not([isArchived])').fadeOut('slow', function(){
			$(this).remove();
		});
	}
	// remove others
	else{
		$(selector).fadeOut('slow', function(){
			$(this).remove();
		});
	}
}

// ------------ doHideNoteAction ------------
function doHideNoteAction( noteId ){
	var stLocal 	= {};

	stLocal.stNote	= sqlGetNote( noteId );

	doCallFloatNoteCloseControl( noteId );
	if( stLocal.stNote.success == true ){
		doShowItemCount( stLocal.stNote.results.type );
		$('#itemGridConteiner_' + noteId).slideUp("slow", deleteElementById( 'itemGridConteiner_' + noteId ));
	}
}

// =========================================
// ============== FLOAT NOTES ==============
// =========================================
// ------------ doFloatNote ------------
function doFloatNote( noteId, x, y, w, h, startMove ){
	var stLocal								= {};
	// open float
	if( typeof nameSpace.floating[noteId] == 'undefined' || typeof nameSpace.floating[noteId].window == 'undefined' ){
		// create loader and content pointer
		stLocal.HTMLLoader						= air.HTMLLoader;
		stLocal.htmlContent						= new air.File("app:/note.html");
		// window options
		stLocal.windowOptions					= new air.NativeWindowInitOptions();
		stLocal.windowOptions.maximizable		= false;
		stLocal.windowOptions.minimizable		= false;
		stLocal.windowOptions.resizable			= false;
		stLocal.windowOptions.systemChrome		= 'none';
		stLocal.windowOptions.transparent		= true;
		stLocal.windowOptions.type				= air.NativeWindowType.LIGHTWEIGHT;
		// window position and size

		var mouseLocation = getScreenMousePosition();

		var strLastFloatPos = sqlGetNoteFloatPosition(noteId).results;
		if(strLastFloatPos&&strLastFloatPos.split){
			var floating = strLastFloatPos.split(',');
		}
		var x,y,w,h;
		if( typeof x == 'undefined' || x == 0 ){
			x = (startMove||!floating)?(mouseLocation.x - 15):parseInt(floating[0]);
		}
		if( typeof y == 'undefined' || y == 0 ){
			y = (startMove||!floating)?(mouseLocation.y - 15):parseInt(floating[1]);
		}
		if( typeof w == 'undefined' || w == 0 ){
			w = (!floating)?nameSpace.noteInfo.width:parseInt(floating[2]);
		}
		if( typeof h == 'undefined' || h == 0 ){
			h = (!floating)?nameSpace.noteInfo.height:parseInt(floating[3]);
		}
		stLocal.Rectangle						= new air.Rectangle( x, y, w, h );
		if(air.Screen.getScreensForRectangle(stLocal.Rectangle).length==0){
			var visibleBounds = air.Screen.mainScreen.visibleBounds;
			stLocal.Rectangle.x = visibleBounds.x+100;
			stLocal.Rectangle.y = visibleBounds.y+100;
		}
		// create and show window
		stLocal.rootWindow						= stLocal.HTMLLoader.createRootWindow( nameSpace.shouldShowFloats , stLocal.windowOptions, false, stLocal.Rectangle );
		// add event listener to inject functions
		nameSpace.floating[noteId]				= {};
		nameSpace.floating[noteId].rootWindow	= stLocal.rootWindow;
		stLocal.rootWindow.addEventListener("htmlDOMInitialize", noteWindowFunctionInjection);
		// set URL vars
		stLocal.URL								= "?noteId=" + noteId;
		if( typeof startMove != 'undefined' ){
			stLocal.URL							= stLocal.URL + "&startMove=" + startMove;
		}
		stLocal.rootWindow.load( new air.URLRequest( stLocal.htmlContent.url + stLocal.URL ) );
		if(nameSpace.shouldShowFloats)
			sqlSaveNoteIsFloating( noteId, true );

		stLocal.saveWindowPosition = function (ev){
			var nw = ev.target;
			sqlSaveNoteFloatPosition(noteId, nw.x+','+nw.y+','+nw.width+','+nw.height);
		};

		nameSpace.floating[noteId].saveWindowPosition = stLocal.saveWindowPosition;

		stLocal.rootWindow.stage.nativeWindow.addEventListener("move", stLocal.saveWindowPosition);
		stLocal.rootWindow.stage.nativeWindow.addEventListener("resize", stLocal.saveWindowPosition);
		doDisplayItemCollapse(noteId);
	}
	else if(x=="shake"){

		var nw = nameSpace.floating[noteId].window;

		nw.removeEventListener("move", nameSpace.floating[noteId].saveWindowPosition);

		nw.orderToFront();

		var oldPos = {x:nw.x, y:nw.y};

		effect(0, 100, 300, function(i){
			if (nw.closed) return true;
			var deltaX = (Math.random()-0.5)*5;
			var deltaY = (Math.random()-0.5)*5;
			nw.x += deltaX;
			nw.y += deltaY;
		}, function(){
			if (nw.closed) return;
			nw.x = oldPos.x;
			nw.y = oldPos.y;
			_setTimeout(function(){
				nw.addEventListener("move", nameSpace.floating[noteId].saveWindowPosition);
			}, 10);
		});

	}else{
		var nw = nameSpace.floating[noteId].window;
		nw.orderToFront();
		if (x == undefined || y == undefined) return;
		nw.x = x;
		nw.y = y;
	}
	$('#itemGridConteiner_'+noteId+' .icon_float_' + noteId+', #itemListConteiner_'+noteId+' .icon_float_' + noteId).hide();
	$('#itemGridConteiner_'+noteId+' .icon_dock_' + noteId+', #itemListConteiner_'+noteId+' .icon_dock_' + noteId).show();

	doHideNoteOptions( noteId );
	doCancelEditNote( noteId );
	doSetNoteTransparency( noteId, nameSpace.floatTransparency );
}

// ------------ effect ------------
// Used for shaking the window
function effect(startPixel, stopPixel, duration, callback, finish){
	var fps = 60;
	var transition = 0;
	var transitionEffect = function(pos){ return Math.pow(pos,2.5); };
	var currentEffect  = 0;
	var startTime = (new Date().getTime());
	var stopTime = startTime + duration;
	var currentPixel = startPixel;

	var interval = _setInterval(function(){
		var time = (new Date().getTime());
		if(time>stopTime) transition = 1;
		else transition = (time-startTime)/duration;
		currentEffect = transitionEffect(transition);
		currentPixel = currentEffect * stopPixel + (1-currentEffect) * startPixel;

		if(nativeWindow.closed || callback(currentPixel) || transition>=1){
			 _clearInterval(interval);
			 interval = null;
			 if(finish) finish();
		}
	}, 1000/fps);
}

// ------------ doRefreshFloatNote ------------
function doRefreshFloatNote( noteId ){
	var stLocal								= {};

	if( typeof nameSpace.floating[noteId] != 'undefined' && typeof nameSpace.floating[noteId].window != 'undefined' ){
		stLocal.windowX			= nameSpace.floating[noteId].window.x;
		stLocal.windowY			= nameSpace.floating[noteId].window.y;
		stLocal.windowW			= nameSpace.floating[noteId].window.width;
		stLocal.windowH			= nameSpace.floating[noteId].window.height;
		doCloseFloatNote( noteId );
		doFloatNote( noteId, stLocal.windowX, stLocal.windowY, stLocal.windowW, stLocal.windowH );
	}
}

// ------------ inject fucntion to login window ------------
function noteWindowFunctionInjection(e){
	var stLocal				= {};

	for( stLocal.noteId in nameSpace.floating ){
		stLocal.stNote		= nameSpace.floating[stLocal.noteId];
		if( typeof stLocal.stNote.window == 'undefined' || stLocal.stNote.window == '' ){
			try{
				stLocal.stNote.rootWindow.window.trace					= trace;
				stLocal.stNote.rootWindow.window.registerNoteWindow		= registerNoteWindow;
				stLocal.stNote.rootWindow.window.getNoteMizSize			= getNoteMizSize;
				stLocal.stNote.rootWindow.window.doCloseFloatNote		= doCloseFloatNote;
				stLocal.stNote.rootWindow.window.doMoveFloatNote		= doMoveFloatNote;
				stLocal.stNote.rootWindow.window.sqlGetNote				= sqlGetNote;
				stLocal.stNote.rootWindow.window.doSaveEditNote			= doSaveEditNote;
				stLocal.stNote.rootWindow.window.getIsConnected			= getIsConnected;
				// inject link options
				stLocal.stNote.rootWindow.window.navigateToURL			= navigateToURL;
				// inject share options
				stLocal.stNote.rootWindow.window.doSearchGoogle			= doSearchGoogle;
				stLocal.stNote.rootWindow.window.doSearchYahoo			= doSearchYahoo;
				stLocal.stNote.rootWindow.window.doMapGoogle			= doMapGoogle;
				stLocal.stNote.rootWindow.window.doMapYahoo				= doMapYahoo;
				stLocal.stNote.rootWindow.window.doShareDelicious		= doShareDelicious;
				stLocal.stNote.rootWindow.window.doShareDigg			= doShareDigg;
				stLocal.stNote.rootWindow.window.doShareReddit			= doShareReddit;
				stLocal.stNote.rootWindow.window.doShareNewsvine		= doShareNewsvine;
				stLocal.stNote.rootWindow.window.doShareFacebook		= doShareFacebook;
			}
			catch(e){
				//trace(e);
			}
		}
	}
}

// ------------ setNoteWindow ------------
function registerNoteWindow( noteId, oWindow ){
	if( typeof nameSpace.floating[noteId].rootWindow != 'undefined' ){
		nameSpace.floating[noteId].window = oWindow;
	}
}

// ------------ doCloseAllFloat ------------
function doCloseAllFloat(){
	var stLocal = {};

	nameSpace.saveFloating = false;
	for( stLocal.thisFloatingNote in nameSpace.floating ){
		stLocal.thisWindow	= nameSpace.floating[stLocal.thisFloatingNote].window;
		if( typeof stLocal.thisWindow != 'undefined' ){
			stLocal.thisWindow.close();
		}
		nameSpace.floating[stLocal.thisFloatingNote] = {};
	}
	nameSpace.saveFloating = true;
}

// ------------ doHideAllFloat ------------
function doHideAllFloat(){
	var stLocal = {};

	for( stLocal.thisFloatingNote in nameSpace.floating ){
		stLocal.thisWindow	= nameSpace.floating[stLocal.thisFloatingNote].window;
		if( typeof stLocal.thisWindow != 'undefined' ){
			stLocal.thisWindow.visible = false;
		}
	}
}

// ------------ doShowAllFloat ------------
function doShowAllFloat(){
	var stLocal = {};

	for( stLocal.thisFloatingNote in nameSpace.floating ){
		stLocal.thisWindow	= nameSpace.floating[stLocal.thisFloatingNote].window;
		if( typeof stLocal.thisWindow != 'undefined' ){
			stLocal.thisWindow.visible = true;
			stLocal.thisWindow.orderInBackOf(nativeWindow);
		}
	}
}

// ------------ doCallFloatNoteShowSaving ------------
function doCallFloatNoteShowSaving( noteId ){
	if( typeof nameSpace.floating[noteId] != 'undefined' && typeof nameSpace.floating[noteId].window != 'undefined' ){
		nameSpace.floating[noteId].rootWindow.window.showSaving();
	}
}

// ------------ doCallFloatNoteCloseControl ------------
function doCallFloatNoteCloseControl( noteId ){
	if( typeof nameSpace.floating[noteId] != 'undefined' && typeof nameSpace.floating[noteId].window != 'undefined' ){
		nameSpace.floating[noteId].rootWindow.window.controlClose();
	}
}

// ------------ doCloseFloatNote ------------
function doCloseFloatNote( noteId ){
	if( typeof nameSpace.floating[noteId] != 'undefined' && typeof nameSpace.floating[noteId].window != 'undefined' ){
		if(nameSpace.saveFloating)
			sqlSaveNoteIsFloating( noteId, false );
		nameSpace.floating[noteId].window.close();
		nameSpace.floating[noteId] = {};
	}
	$('#itemGridConteiner_'+noteId+' .icon_float_' + noteId+', #itemListConteiner_'+noteId+' .icon_float_' + noteId).show();
	$('#itemGridConteiner_'+noteId+' .icon_dock_' + noteId+', #itemListConteiner_'+noteId+' .icon_dock_' + noteId).hide();
	doSetNoteTransparency( noteId, 1 );
}

// ------------ doMoveFloatNote ------------
function doMoveFloatNote( noteId ){
	var stLocal				= {};

	stLocal.event			= window.event;

	if( typeof nameSpace.floating[noteId] != 'undefined' && typeof nameSpace.floating[noteId].window != 'undefined' ){
		doStartDragNewWindow(nameSpace.floating[noteId].window);
	}
}

// ------------ doMoveFloatNote ------------
function doMoveFloatNoteAction(){
//	trace( window.event.pageX )
}

// ------------ doSetNoteTransparency ------------
function doSetNoteTransparency( noteId, transparency ){
	$('#itemGridConteiner_' + noteId).attr('transparency', transparency);
	$('#itemGridConteiner_' + noteId + ' .displayGrid_collapsed').fadeTo( "slow", transparency);
	$('#itemGridConteiner_' + noteId + ' .displayGrid_expanded').fadeTo( "slow", transparency);
	$('#itemListConteiner_' + noteId + ' .displayList_collapsed').fadeTo( "slow", transparency);
	$('#itemListConteiner_' + noteId + ' .displayList_expanded').fadeTo( "slow", transparency);
}

// =========================================
// ============== SYNC CONTENT =============
// =========================================
// ------------ doSetSyncInverval ------------
function doSetSyncInverval(){
	if (nameSpace.isConnected == true) {
		shifdIsKeepAlife(function(result){
			if (!result.success) {
				return;
			}
			nameSpace.sync.intervalId = _setInterval(doSync, 1000 * 60 * nameSpace.sync.minutes);
			if (nameSpace.sync.onInit == true) {
				_setTimeout(doSync, 1000 * 1);
			}
		});
	}
}

// ------------ doStopSyncInverval ------------
function doStopSyncInverval(){
	_clearInterval( nameSpace.sync.intervalId );
	nameSpace.sync.intervalId	= '';
}

// ------------ doSync ------------
function doSync(){
	if (nameSpace.isConnected == true) {
		shifdIsKeepAlife(function(result){
			if (!result.success) {
				return;
			}
			nameSpace.sync.flags = {};
			doSyncBarShow(true);
			_setTimeout(doSyncAction, 1000 * 0.5);
		});
	}
}

// ------------ doSyncBarShow ------------
function doSyncBarShow( isSyncing ){
	if( isSyncing == true ){
		doHideSyncOptions();
		$('#div_statuses').hide();
		$('#sync_amts_lastSync').hide();
		$('#sync_amts_sync').show();
		$('#div_status_synchronizing').show();
	}
	else{
		sqlUserUpdateLastSync( nameSpace.loginUser.userId );
		showLastSyncDate();
	}
}

// ------------ doSyncAction ------------
function doSyncAction(){
	var stLocal					= {};

	stLocal.doEvents			= false

	debug('doSyncAction',0);

	if( nameSpace.isConnected == true) {
		shifdIsKeepAlife(function(result) {
			if (!result.success) {
				return;
			}
			if( typeof nameSpace.sync.flags.syncGetModified == 'undefined' ){
				shifdContentGetModified();
			}
			else if( typeof nameSpace.sync.flags.syncGet == 'undefined' ){
				shifdContentGet();
			}
				else if( typeof nameSpace.sync.flags.syncSend == 'undefined' ){
				syncSend();
			}
			else{
				doSyncBarShow( false );
				// do after sync events
				if( typeof nameSpace.sync.flags.syncGetModified.hasSync != 'undefined' || typeof nameSpace.sync.flags.syncGet.hasSync != 'undefined' ){
					doShowItemCount('note');
					doShowItemCount('link');
					doShowItemCount('place');
				}
			}
		});
	}

	debug('doSyncAction',1);
}

// ------------ showLastSyncDate ------------
function showLastSyncDate(){
	var stLocal		= {};

	$('#sync_amts_sync').hide();
	$('#div_status_synchronizing').hide();
	$('#div_statuses').show();

	stLocal.stLastSync	= sqlUserGetLastSync( nameSpace.loginUser.userId );
	if( stLocal.stLastSync.success && stLocal.stLastSync.results.lastSyncLocal != '' ){
		$('#sync_amts_lastSync').show();
		$('#lastSync').html2( dateFormat( stLocal.stLastSync.results.lastSyncLocal, 4 ) );
	}
	else{
		$('#sync_amts_lastSync').hide();
	}
}

// ------------ syncGetModifiedResponce ------------
function syncGetModifiedResponce( results ){
	var stLocal								= {};

	debug('syncGetModifiedResponce',0);

	nameSpace.sync.flags.syncGetModified	= {};

	if( typeof results == 'object' ){
		for( stLocal.noteIteration in results ){
			stLocal.thisNote				= results[stLocal.noteIteration];
			nameSpace.sync.flags.syncGetModified.hasSync = true;

			// not archived
			if( stLocal.thisNote.state == 0 ){
				stLocal.stNoteToSave				= {};
				stLocal.stNoteToSave.userId			= nameSpace.loginUser.userId;
				stLocal.stNoteToSave.shifdNoteId	= stLocal.thisNote.id;
				stLocal.stNoteToSave.archived		= 0;
				stLocal.stSavesNote					= sqlNoteSaveByShifdNoteId( stLocal.stNoteToSave );
				if( stLocal.stSavesNote.success ){
					doSetContentById( stLocal.stSavesNote.results, true );
				}
			}

			// archived
			if( stLocal.thisNote.state == 1 ){
				stLocal.stNoteToSave				= {};
				stLocal.stNoteToSave.userId			= nameSpace.loginUser.userId;
				stLocal.stNoteToSave.shifdNoteId	= stLocal.thisNote.id;
				stLocal.stNoteToSave.archived		= 1;
				stLocal.stSavesNote					= sqlNoteSaveByShifdNoteId( stLocal.stNoteToSave );
				if( stLocal.stSavesNote.success ){
					doArchiveNote( stLocal.stSavesNote.results );
				}
			}

			// check deleted
			if( stLocal.thisNote.state == 2 ){
				stLocal.stNote						= sqlNoteGetByShifdNoteId( stLocal.thisNote.id );
				if( stLocal.stNote.success ){
					doDeleteNoteAction( stLocal.stNote.results.noteId, 2, false );
				}
			}
		}
	}

	debug('syncGetModifiedResponce',0);
	_setTimeout( doSyncAction, 1000 * 0.1 );
}

// ------------ syncGetResponce ------------
function syncGetResponce( results ){
	var stLocal									= {};

	debug('syncGetResponce',0);

	nameSpace.sync.flags.syncGet				= {};
	stLocal.doDisplayUpdates					= false;

	if( typeof results == 'object' ){
		stLocal.results = results;
		stLocal.localNotesCount = sqlNotesCount(nameSpace.loginUser.userId);
		if (stLocal.localNotesCount.success == true) {
			if (stLocal.localNotesCount.count == 0) {
				nameSpace.firstSync = true;
			}
		}
		stLocal.notesCount = 0;
		stLocal.resultsArray = [];
		for( stLocal.iteration in stLocal.results ){
			stLocal.resultsArray.push(stLocal.results[stLocal.iteration]);
		}
		stLocal.resultsArray.reverse()
		stLocal.results = stLocal.resultsArray;
		stLocal.resultsArray = null;
		stLocal.notesCount = stLocal.results.length;
		stLocal.hideNotes = stLocal.notesCount > 50;
		if (stLocal.hideNotes) {
			showNotesLoading();
		}
		stLocal.noteIteration = 0;
		// sync asynchronously
		$('#filter').attr('disabled', true);
		_setTimeout(doSyncResponceTimer, 1, stLocal, function() {
			nameSpace.firstSync = false;
			_setTimeout( doSyncAction, 1000 * 0.1 );
			$('#filter').attr('disabled', false);
			if (stLocal.hideNotes) {
				hideNotesLoading();
			}
		})
	} else {
		_setTimeout( doSyncAction, 1000 * 0.1 );
	}

	debug('syncGetResponce',1);

}


function doSyncResponceTimer(stLocal, fnFinish) {
	if( stLocal.noteIteration < stLocal.notesCount ){
		var thisNote					= stLocal.results[stLocal.noteIteration];
		nameSpace.sync.flags.syncGet.hasSync	= true;
		var stNoteToSave				= {};
		stNoteToSave.userId			= nameSpace.loginUser.userId;
		stNoteToSave.shifdNoteId	= thisNote.id;
		// set type
		if( thisNote.type_id == 1 ){
			stNoteToSave.type		= 'note';
			stLocal.countContainer	= $('#notesCount');
		}
		else if( thisNote.type_id == 2 ){
			stNoteToSave.type		= 'place';
			stLocal.countContainer	= $('#placesCount');
		}
		else if( thisNote.type_id == 3 ){
			stNoteToSave.type		= 'link';
			stLocal.countContainer	= $('#linksCount');
		}
		// set tag
		if( thisNote.tag == 'null' || thisNote.tag == null ){
			stNoteToSave.tag		= '';
		}
		else{
			stNoteToSave.tag		= thisNote.tag;
		}
		//stLocal.stNoteToSave.content		= URLDecode(stLocal.thisNote.content);
		stNoteToSave.content		= thisNote.content;
		stNoteToSave.archived		= thisNote.state;
		//stLocal.stNoteToSave.toUpdate		= 0;
		stNoteToSave.dateStamp		= thisNote.date_created;
		stNoteToSave.date_modified	= thisNote.date_modified;
		// in sql.js
		var stNote						= sqlNoteSave(stNoteToSave);
		if( stNote.success == true ){
			doSetContentById( stNote.results, stLocal.doDisplayUpdates );
//			stLocal.count = stLocal.countContainer.html2();
//			stLocal.count ++;
//			stLocal.countContainer.html2(stLocal.count.toString());
		}
		stLocal.noteIteration++;
		_setTimeout(doSyncResponceTimer, 1, stLocal, fnFinish);
		return;
	}
	fnFinish.call(window);
}

// ------------ syncSend ------------
function syncSend( noteId ){
	debug('syncSend',0);
	var stLocal						= {};
	stLocal.finish = function() {
		if (typeof noteId == 'undefined') {
			_setTimeout(doSyncAction, 1000 * 0.1);
		}
		else {
			doSyncBarShow(false);
		}
	}

	nameSpace.sync.flags.syncSend	= {};

	if (nameSpace.isConnected == true) {
		shifdIsKeepAlife(function(result){
			if (!result.success) {
				stLocal.finish();
				return;
			}
			var stNotedToSend = {};
			// in sql.js
			if (typeof noteId == 'undefined') {
					stNotedToSend = sqlNoteSetToSend(nameSpace.loginUser.userId);
					stLocal.results = stNotedToSend.results;
			}
			else {
				doSyncBarShow(true);
				stNotedToSend = sqlGetNote(noteId);
				stLocal.results = [];
				stLocal.results[0] = stNotedToSend.results;
			}

			// records exists to send
			if (stNotedToSend.success == true) {
				stLocal.note_idx = 0;
				_setTimeout(syncSendTimer, 1, stLocal);
			} else {
				stLocal.finish();
			}
		});
	}
	else {
		stLocal.finish();
	}
	debug('syncSend',1);
}

// ------------ syncSendTimer ------------
function syncSendTimer(stLocal) {
	if (stLocal.note_idx >= stLocal.results.length) {
		stLocal.finish.call(window);
		return;
	}
	// set each record
	var thisNote	= stLocal.results[stLocal.note_idx];
	// add
	if( typeof thisNote.shifdNoteId == 'undefined' || thisNote.shifdNoteId == null ){
		// in shifd.js
		shifdContentAdd( thisNote.type, thisNote.content, thisNote.dateStamp, thisNote.tag,
			function(stNoteAdd) {
				// check added status
				if( typeof stNoteAdd.success != 'undefined' && stNoteAdd.success == true ){
					debug("Note Added noteId=" + thisNote.noteId);
					var stNoteToSave				= {};
					stNoteToSave.noteId			= thisNote.noteId;
					stNoteToSave.shifdNoteId	= stNoteAdd.results.id;
					stNoteToSave.archived		= stNoteAdd.results.archived;
					stNoteToSave.toUpdate		= 0;
					stNoteToSave.dateStamp		= stNoteAdd.results.date_created;
					stNoteToSave.date_modified	= stNoteAdd.results.date_modified;
					// in sql.js
					sqlNoteSave(stNoteToSave);
				}
				// increase array index
				stLocal.note_idx ++;
				_setTimeout(syncSendTimer, 1, stLocal);
			});
		}
		// delete
		else if( thisNote.toDelete == 1 ){
			// in shifd.js
			shifdContentDelete( thisNote.shifdNoteId,
				function (stNoteDel) {
					debug("Note Deleted noteId = " + stNoteDel.noteId);
					// check updated status
					if( typeof stNoteDel.success != 'undefined' && stNoteDel.success == true ){
						// in sql.js
						sqlNoteDelete(thisNote.noteId );
					};
					// increase array index
					stLocal.note_idx ++;
					_setTimeout(syncSendTimer, 1, stLocal);
				});
	}
	// update
	else if( thisNote.toUpdate == 1 ){
		// in shifd.js
		shifdContentEdit( thisNote.shifdNoteId, thisNote.content, thisNote.type, thisNote.tag, thisNote.date_modified,
			function (stNoteEdit) {
				// check updated status
				if( stNoteEdit.success != 'undefined' && stNoteEdit.success == true ){
					debug("Note Update noteId=" + thisNote.noteId + " type=" + thisNote.type + " content=" + stNoteEdit.content);
					var stNoteToSave			= {};
					stNoteToSave.noteId			= thisNote.noteId;
					stNoteToSave.toUpdate		= 0;
					stNoteToSave.dateStamp		= stNoteEdit.results.date_created;
					stNoteToSave.date_modified	= stNoteEdit.results.date_modified;
					// in sql.js
					sqlNoteSave(stNoteToSave);

				}
				// increase array index
				stLocal.note_idx ++;
				_setTimeout(syncSendTimer, 1, stLocal);
			});
	}
	// charge arhcive state
	else{
		// in shifd.js
		shifdContentChangeState( thisNote.shifdNoteId, thisNote.archived,
			function(stNote) {
				debug("Note Changed shifdId=" + thisNote.shifdNoteId);
				// increase array index
				stLocal.note_idx ++;
				_setTimeout(syncSendTimer, 1, stLocal);
			});
	}
}


// =========================================
// =============== GETTERS =================
// =========================================
// ------------ getIsConnected ------------
function getIsConnected(){
	return nameSpace.isConnected;
}

// ------------ getLoginUser ------------
function getLoginUser(){
	return nameSpace.loginUser;
}

// ------------ getNoteMizSize ------------
function getNoteMizSize(){
	return nameSpace.noteInfo.minSize;
}

// ------------ getWindowSizeInfo ------------
function getWindowSizeInfo(){
	return nameSpace.main;
}

// =========================================
// =============== SETTERS =================
// =========================================
// ------------ setWindowSizeInfo ------------
function setWindowSizeInfo( oWindow ){
	window.nativeWindow.width	= oWindow.width;
	window.nativeWindow.height	= oWindow.height;
	doSetNotesSizes();
	saveMainWindowInitParams();
}


// ===============================================
// =============== GLOBAL EVENTS =================
// ===============================================
var globalListeners = {};

// ----------- addListenerFor --------------------
function addListenerFor(className, eventName, fn){
	var listeners = globalListeners[className];
	if(!listeners){
		listeners = {};
		listeners [eventName] = fn;
		globalListeners[className] = listeners;
	}else{
		listeners [eventName] = fn;
	}
}

// ----------- initGlobalListeners ---------------
function initGlobalListeners(){

	addListenerFor('displayItem_doExpand', 'click',  function(){
		var noteId = $(this).attr('noteId');
		if( typeof nameSpace.floating[noteId] != 'undefined' && typeof nameSpace.floating[noteId].window != 'undefined' )
		{
			doFloatNote( noteId, "shake" );
		}else{
			doDisplayItemExpand( noteId );
		}
	});
	addListenerFor('displayItem_doCollapse', 'click',  function(){ doDisplayItemCollapse( $(this).attr('noteId') ); } );
	addListenerFor('content_html', 'click',  function(){ doEditNote( $(this).attr('noteId') ); } );
	addListenerFor('cancelEditContent', 'click',  function(){ doCancelEditNote( $(this).attr('noteId') ); } );
	addListenerFor('saveContent', 'click',  function(){ doSaveEditNoteById( $(this).attr('noteId') ); } );
	// add focus and blur events
	addListenerFor('doFocusAndBlur', 'click',  function(){ fieldOnFocus(this); } );
	addListenerFor('doFocusAndBlur', 'focus',  function(){ fieldOnFocus(this); } );
	addListenerFor('doFocusAndBlur', 'blur',  function(){ fieldOnBlur(this); } );
	// add link events
	addListenerFor('link', 'click',  function(){ navigateToURL( $(this).attr('content') ); } );
	// add note events actions
	addListenerFor('noteDelete', 'click',  function(event){ doDeleteOrArchiveNote( $(this).attr('noteId'), $(this).attr('archived'), event, false ); } );
	addListenerFor('noteOptions', 'click',  function(){ doShowNoteOptions( $(this).attr('noteId') ); } );
	addListenerFor('noteFloat', 'click',  function(){ doFloatNote( $(this).attr('noteId') ); } );
	addListenerFor('noteCloseFloat', 'click',  function(){ doCloseFloatNote( $(this).attr('noteId') ); } );
	// add note events drag
	//if( isPC() == true ){
		addListenerFor('displayItem_canFloat', 'mousedown',  function(event){ setNoteMouseDown( $(this).attr('noteId'), event ); } );
		addListenerFor('displayItem_canFloat', 'mousemove',  function(event){ setNoteMouseMove( $(this).attr('noteId'), event ); } );
		addListenerFor('displayItem_canFloat', 'mouseup',  function(){ clearNoteMouseUp(); } );
	//}
	// add note share options box events
	debug('doSetDisplayEvents Control',0);
	addListenerFor('option_editNote', 'click',  function(){ doHideNoteOptions( $(this).attr('noteId') ); doEditNote( $(this).attr('noteId') ); } );
	addListenerFor('option_searchGoogle', 'click',  function(){ doHideNoteOptions( $(this).attr('noteId') ); doSearchGoogle( $(this).attr('noteId') ); } );
	addListenerFor('option_searchYahoo', 'click',  function(){ doHideNoteOptions( $(this).attr('noteId') ); doSearchYahoo( $(this).attr('noteId') ); } );
	addListenerFor('option_mapGoogle', 'click',  function(){ doHideNoteOptions( $(this).attr('noteId') ); doMapGoogle( $(this).attr('content') ); } );
	addListenerFor('option_mapYahoo', 'click',  function(){ doHideNoteOptions( $(this).attr('noteId') ); doMapYahoo( $(this).attr('content') ); } );
	addListenerFor('option_shareDelicious', 'click',  function(){ doHideNoteOptions( $(this).attr('noteId') ); doShareDelicious( $(this).attr('content') ); } );
	addListenerFor('option_shareDigg', 'click',  function(){ doHideNoteOptions( $(this).attr('noteId') ); doShareDigg( $(this).attr('content') ); } );
	addListenerFor('option_shareReddit', 'click',  function(){ doHideNoteOptions( $(this).attr('noteId') ); doShareReddit( $(this).attr('content') ); } );
	addListenerFor('option_shareNewsvine', 'click',  function(){ doHideNoteOptions( $(this).attr('noteId') ); doShareNewsvine( $(this).attr('content') ); } );
	addListenerFor('option_shareFacebook', 'click',  function(){ doHideNoteOptions( $(this).attr('noteId') ); doShareFacebook( $(this).attr('content') ); } );


	addListenerFor('itemType', 'click', function(){ noteTypeChange( $(this).attr('title') ) } );
	addListenerFor('status_opener', 'click', doShowSyncOptions);

}

// ------------ dispatchEventFor -----------------
function dispatchEventFor(eventName, ev){
	var node = ev.target;
	while(node){
		if(node.className){
			var classNames = node.className.split(' ');
			for(var i=0,l=classNames.length;i<l;i++){
				var listeners = globalListeners[classNames[i]];
		if(listeners){
			var fn = listeners[eventName];
			if(fn){
				fn.call(node, ev);
				return;
			}
		}
			}
		}
		node = node.parentNode;
	}
}

// ------------ loadGlobalEvents -----------------
function loadGlobalEvents(){
	initGlobalListeners();
	var eventNames = ['click','mousedown','mousemove','mouseup','focus','blur'];
	for(var i=0;i<eventNames.length;i++){
		document.addEventListener(eventNames[i], function(eventName){ return function(ev){
			dispatchEventFor(eventName, ev);
		}}(eventNames[i]) , true);
	}
}

var _timeouts = {};

function _setTimeout(){
	var timeoutId;
	var origFn = arguments[0];
	if(!origFn) return;
	var fn = function(){
		origFn.apply(this, arguments);
		delete _timeouts[timeoutId];
	}
	var args = [];
	for(var i=0,l=arguments.length;i<l;i++){
		args.push(arguments[i]);
	}
	args[0]=origFn;
	timeoutId = setTimeout.apply(this, args);
	_timeouts[timeoutId] = true;
	return timeoutId;
}

function _clearTimeout(timeoutId){
	delete _timeouts[timeoutId];
	clearTimeout(timeoutId);
}

function _clearTimeouts(){
	for(var i in _timeouts){
		clearTimeout(i);
	}
}

var _intervals = {};

function _setInterval(){
	var intervalId;
	var origFn = arguments[0];
	if(!origFn) return;
	var fn = function(){
		origFn.apply(this, arguments);
		delete _intervals[intervalId];
	}
	var args = [];
	for(var i=0,l=arguments.length;i<l;i++){
		args.push(arguments[i]);
	}
	args[0]=origFn;
	intervalId = setInterval.apply(this, args);
	_intervals[intervalId] = true;
	return intervalId;
}

function _clearInterval(intervalId){
	delete _intervals[intervalId];
	clearInterval(intervalId);
}

function _clearIntervals(){
	for(var i in _intervals){
		clearInterval(i);
	}
}

function clearTimers(){
	_clearTimeouts();
	_clearIntervals();
}


function getScreenMousePosition(){
	return nativeWindow.globalToScreen(new runtime.flash.geom.Point(nativeWindow.stage.mouseX, nativeWindow.stage.mouseY ));
}

function doStartDragNewWindow( windowObject ){
	var startingPoint = getScreenMousePosition();

	try{
		windowObject.x = startingPoint.x - 100;
		windowObject.y = startingPoint.y - 15;
	}catch(e){
		return;
	}

	var initialWindowPosition = {x: windowObject.x, y: windowObject.y};
	var delta = {x: initialWindowPosition.x - startingPoint.x, y: initialWindowPosition.y - startingPoint.y};
	var mouseMove = function(e){
		try{
			var newPoint = getScreenMousePosition();
			windowObject.x = delta.x + newPoint.x;
			windowObject.y = delta.y + newPoint.y;
		}catch(e){
			removeListeners();
		}
	};
	var removeListeners = function(e){
		nativeWindow.stage.removeEventListener('mouseUp', removeListeners, true);
		nativeWindow.stage.removeEventListener('mouseMove', mouseMove, true);
		windowObject.stage.removeEventListener('mouseUp', removeListeners, true);
	};
	nativeWindow.stage.addEventListener('mouseUp', removeListeners, true);
	windowObject.stage.addEventListener('mouseUp', removeListeners, true);
	nativeWindow.stage.addEventListener('mouseMove', mouseMove, true);
}


function showInput() {
	setShowInput(nameSpace.loginUser.userId, true);
	$('#add-outer-content').show();
	$('#add-outer').slideDown('slow');
	$('#arrow-up').show();
	$('#arrow-down').hide();
}

function hideInput() {
	setShowInput(nameSpace.loginUser.userId, false);
	$('#add-outer-content').hide();
	$('#add-outer').slideUp('slow');
	$('#arrow-down').show();
	$('#arrow-up').hide();
}

function toggleInput() {

	if($('#add-outer').css('display') == 'none')
		showInput();
	else
		hideInput();
}
