﻿// global vars
var nameSpace = {};

// =========================================
// ================= INIT ==================
// =========================================
// ------------ noteLoad ------------
function noteLoad(){
	getParsedURL();
	setNoteWindow();
	htmlRendererInit();
	getNoteView();
	doControlsLoad();
	if( typeof nameSpace.URL.startMove != 'undefined' ){
		controlMoveByParent();
	}
	setSettings();
	doSetNoteSizes();
	doSetEvents();
	
	nameSpace.isConnected = getIsConnected();
	disableSelection(document.body);
}

// ------------ noteUnload ------------
function noteUnload(){
	doCallClose();
}

nativeWindow.addEventListener('closing', noteUnload);

// =========================================
// ============== PARSE URL ================
// =========================================
// ------------ getParsedURL ------------
function getParsedURL(){
	var stLocal				= {};
	nameSpace.URL			= {};
	
	stLocal.URL				= String(document.location);
	stLocal.aURL			= stLocal.URL.split('?');
	if(stLocal.aURL[1]){
		stLocal.qryString	= stLocal.aURL[1].split('&');
		for( stLocal.URL_idx = 0; stLocal.URL_idx < stLocal.qryString.length ;stLocal.URL_idx++){
			stLocal.thisURL	= stLocal.qryString[stLocal.URL_idx];
			nameSpace.URL[ stLocal.thisURL.split('=')[0] ] = stLocal.thisURL.split('=')[1];
		}
	}
}

// =========================================
// ============== SETTINGS =================
// =========================================
// ------------ setSettings ------------
function setSettings(){
	setMinSize();
	doSetNoteSizes();
}

// ------------ setMinSize ------------
function setMinSize(){
	nameSpace.minSize				= getNoteMizSize();
	window.nativeWindow.minSize		= nameSpace.minSize;
	doSetNoteSizes();
}

// =========================================
// ======== REGISTER NOTE WINDOW ===========
// =========================================
// ------------ getNoteWindow ------------
function setNoteWindow(){
	// in main.js
	try{
		registerNoteWindow( nameSpace.URL.noteId, window.nativeWindow );
	}
	catch(e){
		setTimeout( setNoteWindow, 1000 );
	}
}

// =========================================
// ============== NOTE VIEW ================
// =========================================
// ------------ getNoteView ------------
function getNoteView(){
	var stLocal			= {};
	// get note info
	stLocal.stNote		= sqlGetNote( nameSpace.URL.noteId );
	// div locations
	stLocal.noteArea	= $('#mainContainer');
	// if note exists
	if( stLocal.stNote.success == true ){
		nameSpace.noteType	= stLocal.stNote.results.type;
		// get html content
		if( stLocal.stNote.results.type == 'note' ){
			stLocal.html	= htmlNoteFloat(  nameSpace.URL.noteId, stLocal.stNote.results.content, stLocal.stNote.results.tag, stLocal.stNote.results.dateStamp, stLocal.stNote.results.archived );
		}
		else if( stLocal.stNote.results.type == 'link' ){
			stLocal.html	= htmlLinkFloat(  nameSpace.URL.noteId, stLocal.stNote.results.content, stLocal.stNote.results.tag, stLocal.stNote.results.dateStamp, stLocal.stNote.results.archived );
		}
		else if( stLocal.stNote.results.type == 'place' ){
			stLocal.html	= htmlPlaceFloat(  nameSpace.URL.noteId, stLocal.stNote.results.content, stLocal.stNote.results.tag, stLocal.stNote.results.image, stLocal.stNote.results.dateStamp, stLocal.stNote.results.archived );
		}
		// set html content
		stLocal.noteArea.html( stLocal.html );
		expandWindowToNote();
	}
	else{
		noteUnload();
	}
}

// ------------ showSaving ------------
function showSaving(){
	$('#displayGrid_content').hide();
	$('#edit_content').hide();
	$('#viewTag').hide();
	$('#editTag').hide();
	$('#saving').show();
}

// =========================================
// ============= DISPLAY NOTE ==============
// =========================================
// ------------ expandWindowToNote ------------
function expandWindowToNote() {
	window.nativeWindow.height = parseInt( $('#mainContainer').css('height').replace('px','') );
}

// ------------ doSetNoteSizes ------------
function doSetNoteSizes() {
	var stLocal				= {};
	
	try{
		stLocal.windowHeight		= window.nativeWindow.height;
		stLocal.windowWidth			= window.nativeWindow.width;
		
		stLocal.tagWidth			= stLocal.windowWidth - 140;
		stLocal.contentWidth		= stLocal.windowWidth - 40;
		stLocal.contentHeight		= stLocal.windowHeight - 40;
		stLocal.contentHTMLHeight	= stLocal.windowHeight - 100;
		stLocal.textareaHeight		= stLocal.windowHeight - 90;
		
		$('.content_html').css( 'word-wrap', 'break-word' );
		$('.tag').css( 'width', stLocal.tagWidth );
		$('.displayNote .viewContent').css( 'width', stLocal.contentWidth );
		if( nameSpace.noteType == 'place' ){
			$('.content_html').css( 'width', stLocal.contentWidth - 90 );
		}
		else{
			$('.content_html').css( 'width', stLocal.contentWidth - 20 );
		}
		$('#displayGrid_container').css( 'max-height', stLocal.contentHeight );
		$('#displayGrid_container .content_html').css( 'max-height', stLocal.contentHTMLHeight );
		$('#content').css( 'height', stLocal.textareaHeight );
// This makes the window resize really bad  
//  	window.nativeWindow.minSize = new air.Point(window.nativeWindow.minSize.x, Math.max( nameSpace.minSize.y, parseInt(parseInt($('#displayGrid_container .content_html').css('height').replace('px',''))+100) ) );

	}
	catch(e){
		trace(e);
	}
}

// =========================================
// ================ EVENTS =================
// =========================================
// ------------ doSetEvents ------------
function doSetEvents() {
	$('.doFocusAndBlur').click( function(){ fieldOnFocus(this); } );
	$('.doFocusAndBlur').focus( function(){ fieldOnFocus(this); } );
	$('.doFocusAndBlur').blur( function(){ fieldOnBlur(this); } );
	//
	$('.content_html').click( doEditNote );
	$('.saveContent').click( doSaveFloatNote );
	$('.cancelEditContent').click( doCancelEditNote );
	$('.noteOptions').click( doShowNoteOptions );
	$('.closeOptions').click( doHideNoteOptions );
	$('.option_editNote').click( doEditNote );
	// in main.js
	$('.option_searchGoogle').click( function(){ doSearchGoogle( nameSpace.URL.noteId ); } );
	$('.option_searchYahoo').click( function(){ doSearchYahoo( nameSpace.URL.noteId ); } );
	$('.option_mapGoogle').click( function(){ doMapGoogle( $(this).attr('content') ); } );
	$('.option_mapYahoo').click( function(){ doMapYahoo( $(this).attr('content') ); } );
	$('.option_shareDelicious').click( function(){ doShareDelicious( $(this).attr('content') ); } );
	$('.option_shareDigg').click( function(){ doShareDigg( $(this).attr('content') ); } );
	$('.option_shareReddit').click( function(){ doShareReddit( $(this).attr('content') ); } );
	$('.option_shareNewsvine').click( function(){ doShareNewsvine( $(this).attr('content') ); } );
	$('.option_shareFacebook').click( function(){ doShareFacebook( $(this).attr('content') ); } );
	$('.link').click( function(){ navigateToURL( $(this).attr('content') ); return false; } );
}

// ------------ doShowNoteOptions ------------
function doShowNoteOptions(){
	var stLocal		= {};
	
	if( $('#share-box-holder:visible').size() == 0 ){
		$('#share-box-holder').show();
	}
	else{
		doHideNoteOptions();
	}
}

// ------------ doHideNoteOptions ------------
function doHideNoteOptions(){
	$('#share-box-holder').hide();
}

// =========================================
// ============== EDIT NOTES ===============
// =========================================
// ------------ doEditNote ------------
function doEditNote(){
	$('.floatNoteResize').hide();
	$('#content').val($('#contentOriginal').val());
	$('#tag').val($('#tag').attr('currentValue'));
	$('#displayGrid_content').hide();
	$('#edit_content').show();
	$('#viewTag').hide();
	$('#editTag').show();
	$('#content').focus();
}

// ------------ doCancelEditNote ------------
function doCancelEditNote(){
	$('#displayGrid_content').show();
	$('#edit_content').hide();
	$('.floatNoteResize').show();
	$('#editTag').hide();
	$('#viewTag').show();
}

// ------------ doSaveEditNote ------------
function doSaveFloatNote(){
	var stLocal 	= {};
	
	stLocal.content		= $('#content').val();
	if( $('#tag').val() != $('#tag').attr('title') ){
		stLocal.tag		= $('#tag').val();
	}
	else{
		stLocal.tag		= '';
	}
	
	// in main.js
	doSaveEditNote( nameSpace.URL.noteId, stLocal.content, stLocal.tag );
}