// =========================================
// ================= SESSION ===============
// =========================================
// ------------ login ------------
function shifdLogin( userName, password, callback, callbackArgs) {
	var stData					= {};
	var stReturn				= {};
	var stLocal					= {};
	
	stReturn.success			= true;
	stReturn.results			= '';
	stReturn.message			= 'Login to Shifd Successful';
	stReturn.code				= 0;
	
	stLocal.response = $.ajax({
		type: 'Post',
		url: nameSpace.shifd.URL + 'user/login',
		data: {username:userName,password:password},
		cache: 'false',
		async: true,
		success: function(response, textStatus) {
			try {
				stData = eval("(" + response + ")");
				if( typeof stData.success != 'undefined' ){
					stReturn.results	= stData;
				}
				else{
					stReturn.success	= false;
					stReturn.message	= stData.errors.message;
				}
			}
			catch(e){
				stReturn.success			= false;
				stReturn.message			= 'Connection failure';
			}
			stReturn.username = userName;
			stReturn.password = password;
			stReturn.extra = callbackArgs;
			callback.call(window, stReturn);
		},
		error: function(e) {
			stReturn.success = false;
			stReturn.message = 'Connection failure';
			stReturn.username = userName;
			stReturn.password = password;
			stReturn.extra = callbackArgs;
			callback.call(window, stReturn);
		} 
	});
}

// ------------ logout ------------
function shifdLogout() {
	var stData					= {};
	var stReturn				= {};
	var stLocal					= {};
	
	stReturn.success			= true;
	stReturn.results			= '';
	stReturn.message			= 'Logout to Shifd Successful';
	
	stLocal.response = $.ajax({
		type: 'Get',
		url: nameSpace.shifd.URL + 'user/logout',
		data: {},
		cache: 'false',
		async: false
	});
	
	// connection succesful
	try{
		if( stLocal.response.status == 200 ){
			stData = eval("(" + stLocal.response.responseText + ")");
			if( typeof stData.success != 'undefined' ){
				stReturn.results	= stData;
			}
			else{
				stReturn.success	= false;
				stReturn.message	= stData.errors.message;
			}
		}
		else{
			stReturn.success		= false;
			stReturn.message		= 'Connection failure';
		}
	}
	catch(e){
		stReturn.success			= false;
		stReturn.message			= 'Connection failure';
	}
	
	return stReturn;
}

// ------------ shifdGetInfo ------------
function shifdGetInfo(callback) {
	var stData					= {};
	var stReturn				= {};
	var stLocal					= {};
	
	stReturn.success			= true;
	stReturn.results			= '';
	stReturn.message			= 'User is loged in';
	
	stLocal.response = $.ajax({
		type: 'Get',
		url: nameSpace.shifd.URL + 'user/getInfo',
		data: {},
		cache: 'false',
		async: true,
		success: function(response, textStatus) {
			try {
				stData = eval("(" + response + ")");
				if( typeof stData.success != 'undefined' ){
					stReturn.results	= stData;
				}
				else{
					stReturn.success	= false;
					stReturn.message	= stData.errors.message;
				}
			}
			catch(e){
				stReturn.success			= false;
				stReturn.message			= 'Connection failure';
			}
			callback.call(window, stReturn);
		},
		error: function(e) {
			stReturn.success			= false;
			stReturn.message			= 'Connection failure';
			callback.call(window, stReturn);
		} 		
	});
	
	// connection succesful
//	try{
//		if( stLocal.response.status == 200 ){
//			stData = eval("(" + stLocal.response.responseText + ")");
//			if( typeof stData.success != 'undefined' ){
//				stReturn.results	= stData;
//			}
//			else{
//				stReturn.success	= false;
//				stReturn.message	= stData.errors.message;
//			}
//		}
//		else{
//			stReturn.success		= false;
//			stReturn.message		= 'Connection failure';
//		}
//	}
//	catch(e){
//		stReturn.success			= false;
//		stReturn.message			= 'Connection failure';
//	}
//	
//	return stReturn;
}

// ------------ shifdIsKeepAlife ------------
function shifdIsKeepAlife(callback) {
	var stData					= {};
	var stReturn				= {};
	var stLocal					= {};
	
	stReturn.success			= true;
	stReturn.results			= '';
	stReturn.message			= 'User session is good';
	
	shifdGetInfo(function(info) {
		if (info.success) {
			callback.call(window, stReturn);
			return;
		}
		// try to login
		shifdLogin(nameSpace.loginUser.username, nameSpace.loginUser.password, callback, {});
	});
	
//	if( shifdGetInfo().success == false ){
//		if( shifdLogin( nameSpace.loginUser.username, nameSpace.loginUser.password ).success == false ){
//			stReturn.success	= false;
//			stReturn.results	= '';
//			stReturn.message	= 'User session is bad';
//		}
//	}
	
	return stReturn;
}

// =========================================
// ================ CONTENT ================
// =========================================
// ------------ shifdContentAdd ------------
function shifdContentAdd( type, content, dateStamp, tag, callback ) {
	var stData					= {};
	var stReturn				= {};
	var stLocal					= {};
	
	stReturn.success			= true;
	stReturn.results			= '';
	stReturn.message			= 'Notes Successful added';
	
	if( type == 'place' ){
		stLocal.type_id = 2;
	}
	else if( type == 'link' ){
		stLocal.type_id = 3;
	}
	else{
		stLocal.type_id = 1;
	}
	
	stLocal.response = $.ajax({
		type: 'Get',
		url: nameSpace.shifd.URL + 'content/add',
		data: {type_id:stLocal.type_id,content:content,date_created:dateStamp,tag:tag},
		cache: 'false',
		async: true,
		success: function(response, textStatus) {
			try {
				stData = eval("(" + response + ")");
				if( typeof stData.errors == 'undefined' ){
					stReturn.results	= stData;
				}
				else{
					stReturn.success	= false;
					stReturn.message	= stData.errors.message;
				}
			}
			catch(e){
				stReturn.success			= false;
				stReturn.message			= 'Connection failure';
			}
			callback.call(window, stReturn);
		},
		error: function(e) {
			stReturn.success			= false;
			stReturn.message			= 'Connection failure';
			callback.call(window, stReturn);
		} 
	});
	
	// connection succesful
//	try{
//		if( stLocal.response.status == 200 ){
//			stData = eval("(" + stLocal.response.responseText + ")");
//			if( typeof stData.errors == 'undefined' ){
//				stReturn.results	= stData;
//			}
//			else{
//				stReturn.success	= false;
//				stReturn.message	= stData.errors.message;
//			}
//		}
//		else{
//			stReturn.success		= false;
//			stReturn.message		= 'Connection failure';
//		}
//	}
//	catch(e){
//		stReturn.success			= false;
//		stReturn.message			= 'Connection failure';
//	}
//	
//	return stReturn;
}

// ------------ shifdContentEdit ------------
function shifdContentEdit( shofdNoteId, content, type, tag, date_modified, callback ) {
	var stData					= {};
	var stReturn				= {};
	var stLocal					= {};
	
	stReturn.success			= true;
	stReturn.results			= '';
	stReturn.message			= 'Notes Successful deleted';
	
	if( type == 'place' ){
		stLocal.type_id = 2;
	}
	else if( type == 'link' ){
		stLocal.type_id = 3;
	}
	else{
		stLocal.type_id = 1;
	}
	
	stLocal.response = $.ajax({
		type: 'Get',
		url: nameSpace.shifd.URL + 'content/edit',
		data: {id:shofdNoteId,content:content,type_id:stLocal.type_id,date_modified:date_modified,tag:tag},
		cache: 'false',
		async: true,
		success: function(response, textStatus) {
			try {
				stData = eval("(" + response + ")");
				if( typeof stData.errors != 'undefined' ){
					stReturn.success	= false;
					stReturn.message	= stData.errors.message;
				}
			}
			catch(e){
				stReturn.success			= false;
				stReturn.message			= 'Connection failure on shifdNoteEdit';
			}
			callback.call(window, stReturn);
		},
		error: function(e) {
			stReturn.success			= false;
			stReturn.message			= 'Connection failure on shifdNoteEdit';
			callback.call(window, stReturn);
		} 		
	});
	
	// connection succesful
//	try{
//		if( stLocal.response.status == 200 ){
//			stData = eval("(" + stLocal.response.responseText + ")");
//			if( typeof stData.errors != 'undefined' ){
//				stReturn.success	= false;
//				stReturn.message	= stData.errors.message;
//			}
//		}
//		else{
//			stReturn.success		= false;
//			stReturn.message		= 'Connection failure on shifdNoteEdit';
//		}
//	}
//	catch(e){
//		stReturn.success			= false;
//		stReturn.message			= 'Connection failure on shifdNoteEdit';
//	}
//	
//	return stReturn;
}

// ------------ shifdContentDelete ------------
function shifdContentDelete( shofdNoteId, callback ) {
	var stData					= {};
	var stReturn				= {};
	var stLocal					= {};
	
	stReturn.success			= true;
	stReturn.results			= '';
	stReturn.message			= 'Notes Successful deleted';
	
	stLocal.response = $.ajax({
		type: 'Get',
		url: nameSpace.shifd.URL + 'content/delete',
		data: {id:shofdNoteId},
		cache: 'false',
		async: true,
		success: function(response, textStatus) {
			try {
				stData = eval("(" + response + ")");
				if( typeof stData.errors != 'undefined' ){
					stReturn.success	= false;
					stReturn.message	= stData.errors.message;
				}
			}
			catch(e){
				stReturn.success			= false;
				stReturn.message			= 'Connection failure on shifdNoteDelete';
			}
			callback.call(window, stReturn);
		},
		error: function(e) {
			stReturn.success			= false;
			stReturn.message			= 'Connection failure on shifdNoteDelete';
			callback.call(window, stReturn);
		} 		
	});
	
	// connection succesful
//	try{
//		if( stLocal.response.status == 200 ){
//			stData = eval("(" + stLocal.response.responseText + ")");
//			if( typeof stData.errors != 'undefined' ){
//				stReturn.success	= false;
//				stReturn.message	= stData.errors.message;
//			}
//		}
//		else{
//			stReturn.success		= false;
//			stReturn.message		= 'Connection failure on shifdNoteDelete';
//		}
//	}
//	catch(e){
//		stReturn.success			= false;
//		stReturn.message			= 'Connection failure on shifdNoteDelete';
//	}
//	
//	return stReturn;
}

// ------------ shifdContentGet ------------
function shifdContentGet() {
	var stLocal					= {};
	
	stLocal.stLastSync			= sqlUserGetLastSync( nameSpace.loginUser.userId, -5 );
	
	if( stLocal.stLastSync.success && stLocal.stLastSync.results.lastSync != '' ){
		stLocal.lastSync		= stLocal.stLastSync.results.lastSync;
	}
	else{
		stLocal.lastSync		= 2000;
	}
	
	$.ajax({
		type: 'Get',
		url: nameSpace.shifd.URL + 'content/getList',
		data: {since:stLocal.lastSync},
		cache: 'false',
		async: true,
		success: function(response) {
			stLocal.stData = eval("(" + response + ")");
			if( typeof stLocal.stData.items != 'undefined' ){
				syncGetResponce( stLocal.stData.items );
			}
			else{
				syncGetResponce();
			}
		},
		error: function(e){
			syncGetResponce();
		}
	});
}

// ------------ shifdContentGetModified ------------
function shifdContentGetModified() {
	var stLocal					= {};
	
	stLocal.stLastSync			= sqlUserGetLastSync( nameSpace.loginUser.userId, -5 );
	
	if( stLocal.stLastSync.success && stLocal.stLastSync.results.lastSync != '' ){
		stLocal.lastSync		= stLocal.stLastSync.results.lastSync;
	}
	else{
		stLocal.lastSync		= 2000;
	}
	
	$.ajax({
		type: 'Get',
		url: nameSpace.shifd.URL + 'content/getModified',
		data: {since:stLocal.lastSync}, 
		cache: 'false',
		async: true,
		success: function(response) {
			stLocal.stData = eval("(" + response + ")");
			if( typeof stLocal.stData.items != 'undefined' ){
				syncGetModifiedResponce( stLocal.stData.items );
			}
			else{
				syncGetModifiedResponce();
			}
		},
		error: function(e){
			syncGetModifiedResponce();
		}
	});
}

// ------------ shifdContentChangeState ------------
function shifdContentChangeState( shofdNoteId, archived, callback ) {
	var stData					= {};
	var stReturn				= {};
	var stLocal					= {};
	
	stReturn.success			= true;
	stReturn.results			= '';
	stReturn.message			= 'Notes from Shifd Successful';
	
	if( archived == true ){
		stLocal.state			= 1;
	}
	else{
		stLocal.state			= 0;
	}
	
	stLocal.response = $.ajax({
		type: 'Get',
		url: nameSpace.shifd.URL + 'content/archive',
		data: {id:shofdNoteId,state:stLocal.state}, 
		cache: 'false',
		async: true,
		success: function(response, textStatus) {
			try {
				stData = eval("(" + response + ")");
				if( typeof stData.items != 'undefined' ){
					stReturn.results	= stData.items;
				}
				else{
					stReturn.success	= false;
					stReturn.message	= stData.errors.message;
				}
			}
			catch(e){
				stReturn.success			= false;
				stReturn.message			= 'Connection failure';
			}
			callback.call(window, stReturn);
		},
		error: function(e) {
			stReturn.success			= false;
			stReturn.message			= 'Connection failure';
			callback.call(window, stReturn);
		} 		
	});
	
	// connection succesful
//	try{
//		if( stLocal.response.status == 200 ){
//			stData = eval("(" + stLocal.response.responseText + ")");
//			
//			if( typeof stData.items != 'undefined' ){
//				stReturn.results	= stData.items;
//			}
//			else{
//				stReturn.success	= false;
//				stReturn.message	= stData.errors.message;
//			}
//		}
//		else{
//			stReturn.success		= false;
//			stReturn.message		= 'Connection failure';
//		}
//	}
//	catch(e){
//		stReturn.success			= false;
//		stReturn.message			= 'Connection failure';
//	}
//	
//	return stReturn;
}