// ------------ doCreateSchema ------------
function doCreateSchema(){
	doSchemaUser();
	doSchemaSession();
	doSchemaNote();
	doSchemaVersion();
	doSchemaWindows();
}

// ------------ doSchemaUser ------------
function doSchemaUser(){
	var stLocal					= {};

	stLocal.stmt				= new air.SQLStatement();

	stLocal.stmt.sqlConnection	= dB;
	stLocal.stmt.text			= "CREATE TABLE IF NOT EXISTS user ( " +
								"userId INTEGER PRIMARY KEY AUTOINCREMENT, " +
								"username VARCHAR UNIQUE, " +
								"fname VARCHAR, " +
								"lname VARCHAR, " +
								"email VARCHAR, " +
								"password VARCHAR, " +
								"lastSync DATETIME )";
	try{
		stLocal.stmt.execute();
	}catch(e){
	}
	//
	stLocal.stmt.text			= "ALTER TABLE user ADD COLUMN 'firstTimeArchiving' BOOL NOT NULL DEFAULT true";
	try{
		stLocal.stmt.execute();
	}catch(e){
	}

	//
	stLocal.stmt.text			= "ALTER TABLE user ADD COLUMN 'showInput' BOOL NOT NULL DEFAULT true";
	try{
		stLocal.stmt.execute();
	}catch(e){
	}

}

// ------------ doSchemaSession ------------
function doSchemaSession(){
	var stLocal					= {};

	stLocal.stmt				= new air.SQLStatement();

	stLocal.stmt.sqlConnection	= dB;
	stLocal.stmt.text			= "CREATE TABLE IF NOT EXISTS session ( " +
								"username VARCHAR, " +
								"password VARCHAR )";
	try{
		stLocal.stmt.execute();
	}catch(e){
	}
}

// ------------ doSchemaNote ------------
function doSchemaNote(){
	var stLocal					= {};

	stLocal.stmt				= new air.SQLStatement();

	stLocal.stmt.sqlConnection	= dB;
	stLocal.stmt.text			= "CREATE TABLE IF NOT EXISTS note ( " +
								"noteId INTEGER PRIMARY KEY AUTOINCREMENT, " +
								"userId INTEGER, " +
								"shifdNoteId INTEGER, " +
								"type CHAR DEFAULT 'note', " +
								"content VARCHAR, " +
								"tag VARCHAR, " +
								"archived BOOL NOT NULL DEFAULT 0, " +
								"toDelete BOOL NOT NULL DEFAULT 0, " +
								"toUpdate BOOL NOT NULL DEFAULT 0, " +
								"dateStamp DATETIME NOT NULL DEFAULT CURRENT_TIMESTAMP, " +
								"date_modified DATETIME NOT NULL DEFAULT CURRENT_TIMESTAMP )";
	try{
		stLocal.stmt.execute();
	}catch(e){
	}

	stLocal.stmt.text			= "ALTER TABLE note ADD COLUMN 'lastFloatNotePos' VARCHAR";
	try{
		stLocal.stmt.execute();
	}catch(e){
	}

	stLocal.stmt.text			= "ALTER TABLE note ADD COLUMN 'noteWasFloating' BOOL";
	try{
		stLocal.stmt.execute();
	}catch(e){
	}


}

// ------------ doSchemaVersion ------------
function doSchemaVersion(){
	var stLocal					= {};

	stLocal.stmt				= new air.SQLStatement();

	stLocal.stmt.sqlConnection	= dB;
	stLocal.stmt.text			= "CREATE TABLE IF NOT EXISTS version ( " +
								"version VARCHAR, " +
								"dateStamp DATETIME NOT NULL DEFAULT CURRENT_TIMESTAMP )";
	try{
		stLocal.stmt.execute();
	}catch(e){
	}
}

// ------------ doSchemaWindows ------------
function doSchemaWindows(){
	var stLocal					= {};

	stLocal.stmt				= new air.SQLStatement();

	stLocal.stmt.sqlConnection	= dB;
	stLocal.stmt.text			= "CREATE TABLE IF NOT EXISTS window ( " +
								"name VARCHAR, " +
								"width INTEGER, " +
								"height INTEGER, " +
								"x INTEGER, " +
								"y INTEGER )";
	try{
		stLocal.stmt.execute();
	}catch(e){
	}

}