





function initTooltips(){

	var helper = document.createElement('div');

	document.body.appendChild(helper);

	$(helper).hide().html("Tooltip").css('position','absolute').attr('class', 'tooltip').attr('id','helper');

	$(document.body).bind('mouseover', checkAndShowTooltips);

}



function checkAndShowTooltips(ev){

	var el = $(ev.target);

	while(el.length&&el[0].nodeName.toLowerCase()!='body'){

		var title = el.attr('tooltip');

		if(title&&title!=''){

			showTooltips( title, ev );

			return;

		}

		el=el.parent();

	}

}



function viewport(){

	var w = $(window);

	return {

		x: w.scrollLeft(),

		y: w.scrollTop(),

		cx: w.width(),

		cy: w.height()

	}

}



function showTooltips(title, ev){

	

	$(document.body).bind('mousemove', updateTooltips);

	$(ev.target).one('mouseleave', function(){

		$(document.body).unbind('mousemove', updateTooltips);

		hideTooltips();

	});

	

	$('#helper').show().html(title);



	updateTooltips(ev);

	

}



function updateTooltips(ev){

	var v = viewport();

	var helper = $('#helper');

	var h = helper[0];

	var x = ev.pageX+15, y=ev.pageY+15;

	

	helper.css({

		left: x + 'px',

		top: y + 'px'

	});

	

	// check horizontal position

	if(v.x + v.cx < h.offsetLeft + h.offsetWidth) {

	 	helper.css({left: x - h.offsetWidth - 15 + 'px'});

	}

	// check vertical position

	if(v.y + v.cy < h.offsetTop + h.offsetHeight) {

		helper.css({top: y - h.offsetHeight - 15 + 'px'});

	}

}



function hideTooltips(){

	$('#helper').hide();

}





window.addEventListener('load', initTooltips);