// =========================================
// ============ GLOBAL FUNCTION ============
// =========================================
// ------------ isPC ------------
function isPC(){
	return air.NativeApplication.supportsSystemTrayIcon;
}

// ------------ isMac ------------
function isMac(){
	return air.NativeApplication.supportsDockIcon;
}

// ------------ showDiv ------------
function showDiv(divId){
	// hide current div
	if( nameSpace.currentDiv != '' ){
		$(nameSpace.currentDiv).hide('slow');
	}
	// update current div
	nameSpace.currentDiv = divId;
	// show current div
	$(nameSpace.currentDiv).show('slow');
}

// ------------ fieldOnFocus ------------
function fieldOnFocus( oField ){
	if( oField.value == oField.title ){
		oField.value = '';
	};
}

// ------------ fieldOnBlur ------------
function fieldOnBlur( oField ){
	if( oField.value == '' ){
		oField.value = oField.title;
	}
}

// ------------ doDragEnter ------------
function doDragEnter(event){
	event.returnValue = false;
	event.dataTransfer.dropEffect = "copy";
}

// ------------ doDragOver ------------
function doDragOver(event){
	event.returnValue = false;
	event.dataTransfer.dropEffect = "copy";
}

// ------------ doDrop ------------
function doDrop(event, fieldId){
	var stLocal		= {};
	
	stLocal.data	= event.dataTransfer.getData("text/plain");
	
	event.returnValue = false;
	event.dataTransfer.dropEffect = "copy";
	
	$('#' + fieldId).val(stLocal.data);
	// in main.js
	noteOnKeyUp( $('.' + fieldId) );
}

// ------------ deleteElementById ------------
function deleteElementById( id ){
	var stLocal		= {};
	
	stLocal.element	= document.getElementById(id);
	
	try{
		stLocal.element.parentNode.removeChild( stLocal.element );
	}
	catch(e){}
}


// ------------ dateFormat ------------
function dateFormat( date, formatNumber ){
	var stLocal			= {};
	
	stLocal.success		= true;
	stLocal.myDate		= new Date();
	stLocal.AM_PM		= "am";
	
	stLocal.aDateTime	= date.split(' ');
	if( stLocal.aDateTime.length == 2 ){
		stLocal.aDateParts	= stLocal.aDateTime[0].split('-');
		stLocal.aTimeParts	= stLocal.aDateTime[1].split(':');
		// parse date
		if( stLocal.aDateParts.length == 3 ){
			stLocal.myDate.setYear(stLocal.aDateParts[0]);
			stLocal.myDate.setMonth(stLocal.aDateParts[1]-1);
			stLocal.myDate.setDate(stLocal.aDateParts[2])
		}
		else{
			stLocal.success		= false;
		}
		// parse time
		if( stLocal.aTimeParts.length == 3 ){
			stLocal.myDate.setHours(stLocal.aTimeParts[0]);
			stLocal.myDate.setMinutes(stLocal.aTimeParts[1]);
			stLocal.myDate.setSeconds(stLocal.aTimeParts[2]);
		}
		else{
			stLocal.success		= false;
		}
	}
	else{
		stLocal.success			= false;
	}
	
	// if parsed correctly
	if( stLocal.success == true ){
		stLocal.aMyDateParts			= stLocal.myDate.toString().split(' ');
		
		// ddd mm/dd/yyyy hh:mm tt
		if( formatNumber == 1 ){
			stLocal.returnString		= stLocal.aMyDateParts[0] + ' ' + parseInt(stLocal.myDate.getMonth() + 1) + '/' + stLocal.myDate.getDate() + '/' + stLocal.myDate.getFullYear() + ' ';
			if (stLocal.myDate.getHours() == 0) {
				stLocal.returnString	= stLocal.returnString + '12';
			} 
			else if( stLocal.myDate.getHours() >= 12 ){
				stLocal.returnString	= stLocal.returnString +  (stLocal.myDate.getHours() - (stLocal.myDate.getHours() > 12 ? 12 : 0)).toString();
				stLocal.AM_PM			= "pm";
			}
			else{
				stLocal.returnString	= stLocal.returnString + stLocal.myDate.getHours();
			}
			stLocal.returnString		= stLocal.returnString + ':';
			if( stLocal.myDate.getMinutes().toString().length == 1 ){
				stLocal.returnString	= stLocal.returnString + '0';
			}
			stLocal.returnString		= stLocal.returnString + stLocal.myDate.getMinutes() + ' ';
			stLocal.returnString		= stLocal.returnString + stLocal.AM_PM;
			return stLocal.returnString;
		}
		
		// hh:mm tt
		if( formatNumber == 2 ){
			if (stLocal.myDate.getHours() == 0) {
				stLocal.returnString	= '12';
			} 
			else if( stLocal.myDate.getHours() >= 12 ){
				stLocal.returnString	= (stLocal.myDate.getHours() - (stLocal.myDate.getHours() > 12 ? 12 : 0)).toString();
				stLocal.AM_PM			= "pm";
			}
			else {
				stLocal.returnString	= stLocal.myDate.getHours();
			}
			stLocal.returnString		= stLocal.returnString + ':';
			if( stLocal.myDate.getMinutes().toString().length == 1 ){
				stLocal.returnString	= stLocal.returnString + '0';
			}
			stLocal.returnString		= stLocal.returnString + stLocal.myDate.getMinutes() + ' ';
			stLocal.returnString		= stLocal.returnString + stLocal.AM_PM;			
			return stLocal.returnString;
		}
		
		// ddd mmm dd, yyyy
		if( formatNumber == 3 ){
			stLocal.returnString		= stLocal.aMyDateParts[0] + ' ' + stLocal.aMyDateParts[1] + ' ' + stLocal.myDate.getDate() + ', ' + stLocal.myDate.getFullYear() + ' ';
			return stLocal.returnString;
		}
		
		// mm/dd/yy hh:mm tt
		if( formatNumber == 4 ){
			stLocal.returnString		= parseInt(stLocal.myDate.getMonth() + 1) + '/' + stLocal.myDate.getDate() + '/' + stLocal.myDate.getFullYear().toString().substring(2,4) + ' ';
			if (stLocal.myDate.getHours() == 0) {
				stLocal.returnString	= stLocal.returnString + '12';
			} 
			else if( stLocal.myDate.getHours() >= 12 ){
				stLocal.returnString	= stLocal.returnString +  (stLocal.myDate.getHours() - (stLocal.myDate.getHours() > 12 ? 12 : 0)).toString();
				stLocal.AM_PM			= "pm";
			}
			else {
				stLocal.returnString	= stLocal.returnString + stLocal.myDate.getHours();
			}
			stLocal.returnString		= stLocal.returnString + ':';
			if( stLocal.myDate.getMinutes().toString().length == 1 ){
				stLocal.returnString	= stLocal.returnString + '0';
			}
			stLocal.returnString		= stLocal.returnString + stLocal.myDate.getMinutes() + ' ';
			stLocal.returnString		= stLocal.returnString + stLocal.AM_PM;			
			return stLocal.returnString;
		}
	}
	

	return date;
}

// ------------ trace ------------
function trace( myText ){
	runtime.trace( myText );
}

// ------------ trace ------------
function debug( myText, startEnd ){
	if (nameSpace.debug.enabled == true) {
		if (arguments.length == 1) {
			runtime.trace(new Date().getTime() + ' : ' + myText );
		} else if (arguments.length == 2) {
			if (startEnd == 0) {
				nameSpace.debug[myText] = new Date().getTime();
				runtime.trace(nameSpace.debug[myText] + ' : ' + myText + ' :: START' );
			} else if (startEnd == 1) {
				runtime.trace(nameSpace.debug[myText] + ' : ' + myText + ' :: END | Elapsed Time : ' +  String(Number(new Date().getTime()) - Number(nameSpace.debug[myText])));
			}
		}
	}
}

// ------------ doAlert ------------
function doAlert( message ){
	alert( message );
}

// ------------ stringToHtml ------------
function stringToHtml( string ){
	if( typeof string == 'undefined' || string.length == 0 ){
		return '';
	}
	else{
		return string.replace("<","&lt;").replace(/\r|\n|\r\n/g, "<br>");
	}
}

// ------------ stringToMapFormat ------------
function stringToMapFormat( string ){
	if( typeof string == 'undefined' || string.length == 0 ){
		return '';
	}
	else{
		return string.replace("<","&lt;").replace(/\r|\n|\r\n/g, " ");
	}
}

// ------------ stringToTextareaFormat ------------
function stringToTextareaFormat( string ){
	if( typeof string == 'undefined' || string.length == 0 ){
		return '';
	}
	else{
		return string.replace(/\r|\n|\r\n/g, "\n");
	}
}

// ------------ stringToSQLFormat ------------
function stringToSQLFormat( string ){
	if( typeof string == 'undefined' || string.length == 0 ){
		return '';
	}
	else{
		return string.replace(/\'/g, "''");
	}
}

// ------------ navigateToURL ------------
function navigateToURL( URL ){
	var stLocal					= {};
	
	if( URL.split(':')[0] != 'http' ){
		URL = 'http://' + URL;
	}
	
	stLocal.URLRequest		= new air.URLRequest( URL );
	air.navigateToURL( stLocal.URLRequest );
}

// ------------ doShowWithHideTimeout ------------
function doSetHideTimeout( containerId, seconds ){
	nameSpace.timeout[containerId]	= setTimeout( function(){ $(containerId).hide(); }, 1000 * seconds );
}

// ------------ doStopTimeout ------------
function doStopTimeout( containerId ){
	try{
		clearInterval( nameSpace.timeout[containerId] );	
	}
	catch(e){}
}

// ------------ URLEncode ------------
function URLEncode( plaintext ){
	// The Javascript escape and unescape functions do not correspond
	// with what browsers actually do...
	var SAFECHARS = "0123456789" +                 // Numeric
					"ABCDEFGHIJKLMNOPQRSTUVWXYZ" + // Alphabetic
					"abcdefghijklmnopqrstuvwxyz" +
					"-_.!~*'()";                   // RFC2396 Mark characters
	var HEX = "0123456789ABCDEF";
	
	var encoded = "";
	
	for (var i = 0; i < plaintext.length; i++ ){
		var ch = plaintext.charAt(i);
		if (ch == " ") {
			encoded += "+";                           // x-www-urlencoded, rather than %20
		}
		else if (SAFECHARS.indexOf(ch) != -1){
			encoded += ch;
		}
		else{
			var charCode = ch.charCodeAt(0);
			if (charCode > 255){
				alert( "Unicode Character '" + ch + "' cannot be encoded using standard URL encoding.\n" +
						"(URL encoding only supports 8-bit characters.)\n" +
						"A space (+) will be substituted." );
				encoded += "+";
			}
			else{
				encoded += "%";
				encoded += HEX.charAt((charCode >> 4) & 0xF);
				encoded += HEX.charAt(charCode & 0xF);
			}
		}
	} // for
	return encoded;
};

// ------------ URLDecode ------------
function URLDecode( encoded ){
	// Replace + with ' '
	// Replace %xx with equivalent character
	// Put [ERROR] in output if %xx is invalid.
	var HEXCHARS = "0123456789ABCDEFabcdef"; 
	var plaintext = "";
	var i = 0;
	while (i < encoded.length) {
		var ch = encoded.charAt(i);
		if (ch == "+") {
			plaintext += " ";
			i++;
		}
		else if (ch == "%"){
			if (i < (encoded.length-2) && HEXCHARS.indexOf(encoded.charAt(i+1)) != -1 && HEXCHARS.indexOf(encoded.charAt(i+2)) != -1 ){
				plaintext += unescape( encoded.substr(i,3) );
				i += 3;
			}
			else{
				alert( 'Bad escape combination near ...' + encoded.substr(i) );
				plaintext += "%[ERROR]";
				i++;
			}
		}
		else{
			plaintext += ch;
			i++;
		}
	} // while
	return plaintext;
}

// ------------ guess_the_category ------------
function guess_the_category() {
	var stLocal			= {};
	
	stLocal.note		= $('#note').val();
	
	stLocal.link_clues	= Array('http\:\/\/', 'www\.', '\.com', '\.edu', '\.net', '\.mobile', '\.info');
	for ( stLocal.i in stLocal.link_clues){
		stLocal.re = new RegExp( stLocal.link_clues[stLocal.i], 'stLocal.i' );
		if( stLocal.note.search( stLocal.re ) != -1 ){
			if( $('#itemTypeNote:not(.itemType_unselected)').size() != 0 ){
				noteTypeChange('link');
			}
		}
	}
	
	stLocal.place_clues	= Array(/\s\d{5}/, /\s\d{5}\-\d{4}/ );
	for ( stLocal.i in stLocal.place_clues ){
		if( stLocal.note.search( stLocal.place_clues[stLocal.i] ) != -1 ){
			if( $('#itemTypeNote:not(.itemType_unselected)').size() != 0 ){
				noteTypeChange('place');
			}
		}
	}
}

// ------------ disableSelection ------------

//Sample usages
//disableSelection(document.body) //Disable text selection on entire body
//disableSelection(document.getElementById("mydiv")) //Disable text selection on element with id="mydiv"

function disableSelection(target){
	if (typeof target.onselectstart!="undefined") //IE route
		target.onselectstart=function(){return false}
	else if (typeof target.style.MozUserSelect!="undefined") //Firefox route
		target.style.MozUserSelect="none"
	else //All other route (ie: Opera)
		target.onmousedown=function(){return false}
	target.style.cursor = "default"
}

