// =========================================
// ================= INIT ==================
// =========================================
// ------------ appLoad ------------
function updaterLoad(){
	defaultVersion();
	deleteCurrentUpdaters();
	checkNewVersion();
}

// =========================================
// ================ DEFAULT ================
// =========================================
// ------------ defaultVersion ------------
function defaultVersion(){
	sqlVersionSet( nameSpace.version.version );
}

// ------------ deleteCurrentUpdaters ------------
function deleteCurrentUpdaters(){
	var stLocal						= {};

	// delete updater directory (true = deleteDirectoryContents)
	stLocal.directory				= air.File.applicationStorageDirectory.resolvePath("updaters/");
	if( stLocal.directory.exists ){
		stLocal.directory.deleteDirectory(true);
	}
}

// =========================================
// ================ UPDATER ================
// =========================================
// ------------ checkNewVersion ------------
function checkNewVersion(){
	var stLocal						= {};

	stLocal.urlString				= nameSpace.links.version + nameSpace.version.fileName;
	stLocal.urlReq					= new air.URLRequest( stLocal.urlString );
	nameSpace.version.updaterData	= new air.ByteArray();
	nameSpace.version.updaterStream	= new air.URLStream();
	nameSpace.version.updaterStream.addEventListener(air.Event.COMPLETE, updaterFileLoaded);
	nameSpace.version.updaterStream.addEventListener(air.IOErrorEvent.IO_ERROR, ioErrorHandler);
	nameSpace.version.updaterStream.load( stLocal.urlReq );
}

// ------------ updaterFileLoaded ------------
function updaterFileLoaded(){
	var stLocal			= {};

	nameSpace.version.updaterStream.readBytes(nameSpace.version.updaterData, 0, nameSpace.version.updaterStream);
	writeUpdaterFile();
}

// ------------ ioErrorHandler ------------
function ioErrorHandler(event){
	//trace(event);
	showLogin();
}

// ------------ writeUpdaterFile ------------
function writeUpdaterFile(){
	var stLocal			= {};

	stLocal.file		= air.File.applicationStorageDirectory.resolvePath( nameSpace.version.fileName );
	stLocal.fileStream	= new air.FileStream();
	stLocal.fileStream.addEventListener(air.Event.CLOSE, updaterReady);
	stLocal.fileStream.openAsync(stLocal.file, air.FileMode.WRITE);
    stLocal.fileStream.writeBytes(nameSpace.version.updaterData, 0, nameSpace.version.updaterData.length);
    stLocal.fileStream.close();
}

// ------------ updaterReady ------------
function updaterReady() {
	var stLocal					= {};

	stLocal.textStream			= new air.FileStream();

	stLocal.textFile			= air.File.applicationStorageDirectory.resolvePath( nameSpace.version.fileName );

	if(stLocal.textFile.exists){
		stLocal.textStream.open(stLocal.textFile, air.FileMode.READ);
		stLocal.fileContent		= stLocal.textStream.readUTFBytes(stLocal.textStream.bytesAvailable);

		//replace with xml parse
			stLocal.version		= stLocal.fileContent.split(',')[0];
			stLocal.filePath	= stLocal.fileContent.split(',')[1];
		//end of replace with xml parse
		stLocal.stIsNew			= checkIsNew( stLocal.version, stLocal.filePath );

		if( stLocal.stIsNew.isNew == true ){
			if( stLocal.stIsNew.forceNew == true ){
				alert('A new required update of the ShifD application is available.');
				getNewVersion();
			}
			else{
				if( confirm('A new version of the ShifD application is available. Get it now?') ){
					getNewVersion();
				}
				else{
					showLogin();
				}
			}
		}
		else{
			showLogin();
		}
	}
}

// ------------ checkIsNew ------------
function checkIsNew( version, filePath ) {
	var stReturn			= {};
	var stLocal				= {};

	stReturn.isNew			= false;
	stReturn.forceNew		= false;

	// current version
	stLocal.stVersion		= sqlVersionGet();
	stLocal.versionCurrent	= stLocal.stVersion.results.version;
	stLocal.aCurrent		= stLocal.versionCurrent.split('.');
	// check file
	stLocal.aCheck			= version.split('.');

	// loop on version
	for( stLocal.versionIdx = 0; stLocal.versionIdx < stLocal.aCheck.length; stLocal.versionIdx++ ){
		if( typeof stLocal.aCurrent[stLocal.versionIdx] == 'undefined' || stLocal.aCheck[stLocal.versionIdx] > stLocal.aCurrent[stLocal.versionIdx] ){
			stReturn.isNew				= true;
			nameSpace.version.filePath	= filePath;
			nameSpace.version.version	= version;
			if( stLocal.versionIdx < 2 ){
				stReturn.forceNew		= true;
			}
		}
	}

	return stReturn;
}

// =========================================
// ================ GETFILE ================
// =========================================
// ------------ getNewVersion ------------
function getNewVersion(){
	var stLocal						= {};

	stLocal.urlString				= nameSpace.version.filePath;
	stLocal.urlReq					= new air.URLRequest( stLocal.urlString );
	nameSpace.version.versionStream	= new air.URLStream();
	nameSpace.version.versionData	= new air.ByteArray();
	nameSpace.version.versionStream.addEventListener(air.Event.COMPLETE, versionFileLoaded);
	nameSpace.version.versionStream.addEventListener(air.IOErrorEvent.IO_ERROR, ioErrorHandler);
	nameSpace.version.versionStream.load(stLocal.urlReq);
}

// ------------ versionFileLoaded ------------
function versionFileLoaded(event){
	nameSpace.version.versionStream.readBytes(nameSpace.version.versionData, 0, nameSpace.version.versionStream.bytesAvailable);
    writeVersionFile();
}

// ------------ writeVersionFile ------------
function writeVersionFile() {
    var stLocal						= {};

	stLocal.aFilePath				= nameSpace.version.filePath.split('/');
	nameSpace.version.versionFile	= stLocal.aFilePath[stLocal.aFilePath.length-1];

	stLocal.file					= air.File.applicationStorageDirectory.resolvePath( 'updaters/' + nameSpace.version.versionFile );
    stLocal.fileStream				= new air.FileStream();
	stLocal.fileStream.addEventListener(air.Event.CLOSE, versionReady);
    stLocal.fileStream.openAsync(stLocal.file, air.FileMode.WRITE);
    stLocal.fileStream.writeBytes(nameSpace.version.versionData, 0, nameSpace.version.versionData.length);
    stLocal.fileStream.close();
}

// ------------ versionReady ------------
function versionReady() {
    var stLocal						= {};

	stLocal.updater					= new air.Updater();
	stLocal.airFile					= air.File.applicationStorageDirectory.resolvePath( 'updaters/' + nameSpace.version.versionFile );
	stLocal.updater.update( stLocal.airFile, nameSpace.version.version );
}